#ifndef __AUDIOENC__
#define __AUDIOENC__
/*audeoenc.h
interface to the audio encoder functions
*/

#include <windows.h>

enum EStereoType {STEREO, JOINT_STEREO, DUAL_CHANNEL, MONO};
enum ESamplingFreq {SF_44100_HZ, SF_48000_HZ, SF_32000_HZ};

#define MONO_INPUT_SIZE 1152
#define STEREO_INPUT_SIZE (2*MONO_INPUT_SIZE)


//create an audio encoder object, return pointer as handle
HANDLE WINAPI CreateAudioEncoder( ESamplingFreq Freq,  
     				                EStereoType Type,
    				                int BitRate/*(in KHz)*/);
//remove audio encoder object
void WINAPI DeleteAudioEncoder(HANDLE AudioObj);

//return size of next audio frame output in bytes
int WINAPI GetNextAudioFrameSize(HANDLE AudioObj);

//return size of max audio frame output in bytes
int WINAPI GetMaxAudioFrameSize(HANDLE AudioObj);

//process a frame of audio data
void WINAPI ProcessFrame(  HANDLE AudioObj,
                             short *FrameInput,    //1152 16 bit samples or 2*1152 16 samples for stereo
						     BYTE  *FrameOutput);  //(1152 * (bit rate / 8) / sample rate) bytes on 
											  //average (output size may vary by 1 byte)
#endif  //#ifndef __AUDIOENC__
