#ifndef __DELAY__
#define __DELAY__

/*delay.h
This file is the interface to the CDelay class.
This class is used to delay a stream of floats by a fixed
amount.  The input/output buffer size is also fixed at class
construction.  The AddData method is used to input data into
the delay line (and to push out old data).
The GetData method returns a pointer to data
that is delayed from the last call to AddData.

*/

class CDelay {
	//data members
	private:
	float *DelayLine;
	int delay;  //ammount to delay input
	int BuffSize;
	int LineSize;
	float *inptr,*outptr;
	float *LastOutBuff;			//pointer to the last output buffer
	int LastCopySize;			//size of partial copy at end of delay line

	//interface
	public:
	CDelay(int BufferSize=36*32, int Delay=256-64);
	~CDelay();
	void AddData(float *NewInput);	//add input to the delay line

	float *GetData(void)			//fetch current delayed output buffer
	{
		return outptr;
	};
};

#endif  //#ifdef __DELAY__
