/*if.cpp
this file contains code to wrap the interface of the mpeg audio
compression class into C callable dll functions
*/

#include "encode.h"
#include <windows.h>

#define DLLEXPORT   __declspec(dllexport)

DLLEXPORT HANDLE WINAPI CreateAudioEncoder( ESamplingFreq Freq,  
     				                EStereoType Type,
    				                int BitRate/*(in KHz)*/)
/*
create an audio encoder object, return pointer as handle
*/
{
    return (HANDLE)new CAudioEncode(Freq, Type, BitRate);
}


DLLEXPORT void WINAPI DeleteAudioEncoder(HANDLE AudioObj)
/*
remove audio encoder object
*/
{
    delete (CAudioEncode *)AudioObj;
}


DLLEXPORT int WINAPI GetNextAudioFrameSize(HANDLE AudioObj)
/*
return size of next audio frame output in bytes
*/
{
    return ((CAudioEncode *)AudioObj)->GetNextFrameSize();
}




DLLEXPORT int WINAPI GetMaxAudioFrameSize(HANDLE AudioObj)
/*
return size of max audio frame output in bytes
*/
{
    return ((CAudioEncode *)AudioObj)->GetMaxFrameSize();
}




DLLEXPORT void WINAPI ProcessFrame(  HANDLE AudioObj,
							 int   combined_smr,
							 int   *maxsb,
                             short *FrameInput,    //1152 16 bit samples or 2*1152 16 samples for stereo
						     BYTE  *FrameOutput)  //(1152 * (bit rate / 8) / sample rate) bytes on 
											  //average (output size may vary by 1 byte)
/*
process a frame of audio data
*/
{
    ((CAudioEncode *)AudioObj)->ProcessFrame(FrameInput, FrameOutput, combined_smr,maxsb);
}

