#ifndef __CIRBUF__
#define __CIRBUF__
/*cirbuf.h
This is the interface to a simple class that implements a circular buffer
*/
#define CBT unsigned long
class CBasePin;
class CCircBuffer {
public:
	void Initialize(CBT *Buffer, int Size);
	int ValidData() {
	    return  (m_ReadLoc<=m_WriteLoc ? m_WriteLoc-m_ReadLoc :m_Size-(m_ReadLoc-m_WriteLoc) );
	}
	int MaxRead() {
	    return (m_ReadLoc<=m_WriteLoc ? m_WriteLoc-m_ReadLoc :m_Size-m_ReadLoc);
	}
	int FreeSpace() ;
    void GetDataPointers(CBT **ptr1, int *size1, CBT **ptr2, int *size2) {
        if (m_ReadLoc<=m_WriteLoc) {
            *size1 = m_WriteLoc-m_ReadLoc;
            *ptr1 = &m_Buffer[m_ReadLoc];
            *size2 = 0;
            *ptr2 = NULL;
        }
        else {
            *size1 = m_Size-m_ReadLoc;
            *ptr1 = &m_Buffer[m_ReadLoc];
            *size2 = m_WriteLoc;
            *ptr2 = m_Buffer;
        }
    };
    void SetWriteLocation(int loc) {m_WriteLoc = loc;};
    void SetWriteLocation(CBT *ptr) {m_WriteLoc = ptr - m_Buffer;};
    void SetReadLocation(int loc)  {m_ReadLoc = loc;};
	int FlushToFile(HANDLE hFile);
	int FlushToPin(CBasePin *Pin);

protected:
	CBT *m_Buffer;
	int m_Size;
	int m_ReadLoc,m_WriteLoc;
};

#endif  //#ifndef __CIRBUF__
