/* @(#)dmem.h	1.9 4/2/97 */
/*************************************************************************
 *
 * Copyright C-Cube Microsystems 1995
 *
 *************************************************************************/


#define D_FRAME_NUMBER		(0x1FE << 2)
#define D_EVEN_FIELD		(0x1FF << 2)
#define D_REPEAT_CNT		(0x200 << 2)
#define D_SKIP_CNT		(0x201 << 2)
#define D_LINE_NO		(0x202 << 2)
#define D_FIRST_ACTIVE_LINE	(0x210 << 2)  /* -10 */
#define D_CHMEM4_INIT		(0x211 << 2)  /* (0x1FF<<23) | D_Vid[12]_BUF | 0x2 */
#define D_MB_ROW_INC		(0x212 << 2)  /* 16*2*width - 64 */
#define D_VBCTL_WORD		(0x213 << 2)  /* (0x7 << 29) | VIDB_BUS_WIDTH | 0x9 */
#define D_FORCED_REPEATS	(0x214 << 2)  /* should remain 0/1 if the performance is OK */
#define D_BS_READ_PTR		(0x215 << 2)  /* bitstream buffer read pointer */
#define D_BS_WRITE_PTR		(0x216 << 2)  /* bitstream buffer write pointer */
#define D_ENC_MON_FLAG		(0x217 << 2)  /* enc_mon flag */

/* 
 * Video mode definitions:
 *    0 - output frames with vsync and repeat fields;
 *    1 - output frames with vsync and no repeat fields;
 *    2 - output frames without vsync and repeat fields. (not implemented now)
 * For mode 1 and 2, horizontal interpolation will be turned off and
 * video B bus will function in master mode.
 */

#define D_VIDEO_MODE 		(0x218 << 2)  
#define D_NEW_FRAME_RDY_FLAG	(0x219 << 2) 
#define D_FULLNESS		(0x21a << 2)
#define D_VLD_NOT_RDY		(0x21b << 2)
#define D_DEBUG_PTR		(0x21c << 2)
#define D_VIDA_BUS_WIDTH	(0x21d << 2)
#define D_VIDB_BUS_WIDTH	(0x21e << 2)

/* AUDIO START REGISTER LOCATION */
#define DA_DUMMY			(0x3dd << 2)
#define DA_AUDIO_START_REG		(0x3de << 2)

/* STACK SAVE DMEM LOCATION WHEN ENTERING SLICE */
#define SP_SAVE_DADR		(0x3ee << 2)

#define BASE                    (0x9000)

/* @@@@@@@@@@@@@@@@@@ START OF THE BUFFERS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */

#define BUF_HDEC_SIZE			(2*18*22*128)
#define BUF_REF_LUMA_SIZE		(18*22*64)
#define BUF_REF_CHROMA_SIZE		(18*22*32)
#define BUF_SIF_LUMA_SIZE		(18*22*64)
#define BUF_SIF_CHROMA_SIZE		(18*22*32)
#define INPUT_BS_SIZE                   (0x4000)
#define QM_SIZE                         (2*32*32) 

#define	COS_TABLE_SIZE		(32)
#define DQUANT_TABLE_SIZE        (32)
#define NUM_DQUANT_TABLES        (32)
#define TOTAL_DQUANT_TABLE_SIZE		(DQUANT_TABLE_SIZE*NUM_DQUANT_TABLES)
#define BUF_START_ADDR			(BASE)

/*------------------------------------------------*/

#define         D_Vid_frame1    (BUF_START_ADDR)      
#define         D_Vid_frame2    (D_Vid_frame1+BUF_HDEC_SIZE)  
#define         D_Vid_frame3    (D_Vid_frame2+BUF_HDEC_SIZE)  
#define         D_RefY_frame    (D_Vid_frame3 + BUF_HDEC_SIZE)
#define         D_RefY_frame1   (D_RefY_frame)
#define         D_RefY_frame2   (D_RefY_frame1 + BUF_SIF_LUMA_SIZE)
#define         D_RefY_frame3   (D_RefY_frame2 + BUF_SIF_LUMA_SIZE)
#define         D_RefC_frame1   (D_RefY_frame3 + BUF_SIF_LUMA_SIZE)
#define         D_RefC_frame2   (D_RefC_frame1 + BUF_SIF_CHROMA_SIZE)
#define         D_RefC_frame3   (D_RefC_frame2 + BUF_SIF_CHROMA_SIZE)
#define         D_Test_Video_Frame (D_Vid_frame3 + BUF_HDEC_SIZE)
#define         D_BITS_BUF      ((D_RefC_frame3 + BUF_SIF_CHROMA_SIZE + 0x3ff) & ~0x3ff)
#define         D_test_block    (D_BITS_BUF+INPUT_BS_SIZE)
#define BUF_END_ADDR		(D_test_block + 0x60)

/* @@@@@@@@@@@@@@@@@@ END OF THE BUFFERS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */

#define         D_IDQM_Tbls     (BUF_END_ADDR)   /* 32*31=992 words */
#define         D_DQM_VBase     (D_IDQM_Tbls - (2*32))  /* virtual address */
#define         D_QMShift_Tbl   (D_DQM_VBase + QM_SIZE)         /* 32 words        */

#define	D_COS_TABLE		(D_QMShift_Tbl + 32)

#define D_TRASH                	(D_COS_TABLE + COS_TABLE_SIZE)
#define D_BITS_BUF_VLD		(D_BITS_BUF)

/* *************************************************** */
 

