/* Copyright C-Cube Microsystems 1995	*/
/*	@(#)default.h	1.4	6/11/93	*/
/*************************************************************************
 *
 * C-Cube Microsystems
 *
 *************************************************************************/

/*************************************************************************
 *
 * Filename:  default.h
 * Author:  Stewart Kelly
 * Purpose:  MPEG encoder defaults include file
 * Date:  5/18/93
 *
 *************************************************************************/

/*
 * define parameter sets for various standard apps
 *
 *  HORIZ_SIZE:        image width in pixels
 *  VERT_SIZE:         image height in pixels
 *  PEL_ASPECT_RATIO:  MPEG sequence header code for aspect ratio (4 bits)
 *  PICTURE_RATE:      MPEG sequence header code for picture rate (4 bits)
 *
 */

/*
 * default settings for CCIR-601 - 704 x 480
 */
#ifdef	R601_704_480
#define	R601
#define	HORIZ_SIZE		704
#define	VERT_SIZE		480
#define	PEL_ASPECT_RATIO	0xc
#define	PICTURE_RATE		0x4
#define	NUM_CHIPS		8

#if CHIP_NUM == 7
#define	TRAIL_VIDWAIT_L_NO	505
#else
#define	TRAIL_VIDWAIT_L_NO	490
#endif

#define	VIDA_FILT_MODE		0x2	/* YUV sep only */

#define	NUM_WDS_PER_LINE	((2 * 704) / 4)
#define	LINE_TO_LINE_INC	8

#endif

/*
 * default settings for SIF
 */
#ifdef	SIF
#define	HORIZ_SIZE		352
#define	VERT_SIZE		240
#define	PEL_ASPECT_RATIO	0xc
#define	PICTURE_RATE		0x4
#define	NUM_CHIPS		2

#define	VIDA_FILT_MODE		0x1	/* SIF decimation */

#define	NUM_WDS_PER_LINE	((2 * 352) / 4)
#define	LINE_TO_LINE_INC	4

#endif

/*************************************************************************
 *
 * C-Cube Microsystems
 *
 *************************************************************************/
