/* Copyright C-Cube Microsystems 1995	*/
/*    @(#)dmem.h	35.32 5/7/96         */

/* FREE SPACE FOR STATUS INDICATORS */
#define SAVE_SCENE_CHANGE_DETECT      (0x1F7 << 2)
#define SAVE_SCENE_CHANGE_INTRA       (0x1F8 << 2)
#define SAVE_SCENE_CHANGE_ENHANCED    (0x1F9 << 2)
#define SAVE_PANIC_FRAMES             (0x1FA << 2)

#define SAVE_FRAME_NUMBER       (0x1FE << 2)
#define SAVE_SKIPPED_FRAMES     (0x1FF << 2)


#define D_BS_READ_PTR           (0x230 << 2)
#define D_BS_WRITE_PTR          (0x231 << 2)
#define D_FULLNESS              (0x232 << 2)
#define D_VLD_NOT_RDY           (0x233 << 2)
#define D_CHMEM5_REQ            (0x234 << 2)
#define D_VID_A_CNT             (0x235 << 2)
#define D_VLD_CNT               (0x236 << 2)
#define D_VLINE_THRES           (0x237 << 2)

#define DA_REFB_SCHED_B_PING    (0x7F000 << 2)
#define DA_REFB_SCHED_B_PONG    (0x7F400 << 2) 

/* CAN BE MOVED: DEBUG PTR */
#define	INV32_MON_SEMAPHORE  	(0x3A8 << 2)	/* MATCH1 */
#define	INV32_MON_PTR  		(0x3A9 << 2)	/* to 3AC */

/* INV32 DEBUG CONTROL: CAN BE MOVED */
/* Bitmap register:
 *	[0]	MB stat preference enable
 *	[1]	INV32_mon enable
 *	[2]	debug (chroma on bad decision) enable
 *	[4..12]	MBs with preference threshold
 */
#define DA_INV32_CONTROL	(0x386 << 2)
#define INV32_MB_PREF_ENABLE	(0x1)
#define INV32_MON_ENABLE	(0x2)
#define INV32_DEBUG_ENABLE	(0x4)
#define INV32_THRESH_SHIFT	(0x3)	/* shift to apply */

/* PTS offset location	*/
#define DA_PTS_OFFSET		(0x387 << 2)

/*
 *----------------------------------------------------------------------------
 * Locations used to communicate new video capture window setup from master to
 * slave.  The new setup cannot be written directly to 
 * SLAVE_DA_XXX_FIRST_VIS_OFFSET since it is not safe until the encoder has
 * been started, at which time we are guaranteed to have the correct video
 * input, unless the host has totally screwed up.
 *----------------------------------------------------------------------------
 */
#define DA_NEW_EVEN_VIS_OFFSET		(0x388 << 2)
#define DA_NEW_ODD_VIS_OFFSET		(0x389 << 2)

/*
 *----------------------------------------------------------------------------
 * Flag to indicate whether or not to do internal decimation.  1 == do internal
 * decimation, 0 == don't.
 *----------------------------------------------------------------------------
 */
#define DA_DECIMATION_FLAG		(0x38a << 2)

/*
 *----------------------------------------------------------------------------
 * Locations to store video A and B bus widths.
 *----------------------------------------------------------------------------
 */
#define DA_WIDE_VIDA_FLAG		(0x38b << 2)
#define DA_WIDE_VIDB_FLAG		(0x38c << 2)
#define DA_VIDB_BUS_WIDTH_CTL		(0x38d << 2)

/*
 *----------------------------------------------------------------------------
 * Location for scence change detection control bitflags.  Currently, two
 * flags are defined:
 *
 *  [0]: 0 ==> No automatic scene change detection performed.
 *       1 ==> Automatic scene change detection performed, including
 *             start new GOP and rate control reset.
 *  [1]: 0 ==> Rate control reset is not performed when the Start GOP
 *             command is issued by the host.  If automatic scene change
 *             detection is on, this will not affect the rate control
 *             reset done when a scene change is detected.
 *       1 ==> Rate control reset is performed when the Start GOP
 *             command is issued by the host.  This is useful for external
 *             scene change detection.
 *----------------------------------------------------------------------------
 */
#define DA_SCENE_CHANGE_CONTROL		(0x38e << 2)
#define AUTO_SCD_MASK			(0x1)
#define RC_RESET_MASK			(0x2)
#define RC_PENALTY_MASK			(0x4)

/*
 *----------------------------------------------------------------------------
 * Location for bit distribution clipping control.  This controls how strong
 * the clipping is on the bit distribution between the chips.  The value must
 * be in units of 1/32 and must be between 6 (3/16) and 16 (1/2).  Example:
 * with a value of 12 in this location, neither chip can have less than 3/8
 * (12/32) of the total bit budget.
 *
 * This control is useful in situations where one chip has so much more
 * activity than the other that it starves the other chip of bits (in extreme
 * cases, activity isn't always a good indicator of bit allocation).  This
 * can arise, for example, in the case of karaoke titles.  The titles come out
 * looking pretty clear, but the chip without the titles looks like blocky.
 *
 * The default clipping is 1/4 (a value of 8).  This is setup in main.c: if
 * there isn't something already written to this location, the encoder
 * initialization will write an 8.  The value is processed by
 * rc0_master_pre_pic() in picture.c.  There, it is checked for being out of
 * range.
 *
 * This value can be changed at any time, either on the fly or when the
 * encoder is stopped.
 *----------------------------------------------------------------------------
 */
#define DA_BIT_DIST_CLIP_CONTROL	(0x38f << 2)
/*
 *----------------------------------------------------------------------------
 * Location to hold threshold for determining whether a command timecode is
 * expired or a wraparound.  If a timecode is in the past by less than this
 * threshold, it is considered to be expired and is discarded.  If it is further
 * in the past than this threshold, it is considered to actually be in the
 * future via wraparound and is processed at the appropriate time.
 *
 * This threshold is in BCD timecode format (0xHHMMSSFF) and can have any
 * value between 0:0:0:1 and 23:0:0:0.
 *----------------------------------------------------------------------------
 */
#define DA_DISCARD_THRESHOLD		(0x390 << 2)

/* 8 lsb quant, 24 msb activity level.  Turning off would be 0x7FFFFF01 */
#define	DA_QUANT_ADJ			(0x391 << 2)

/* Location for bit stuffing control */
#define DA_STUFFING_FLAG             (0x394 << 2)

/* Location for I_Codec Encode/Decode mode control */
#define DA_DECODER_FLAG            (0x395 << 2)


/*
 *----------------------------------------------------------------------------
 * Location to hold flag for closing the next GOP.  This has to be set up
 * (using the Close GOP UI command) one frame in advance.
 *----------------------------------------------------------------------------
 */
#define	DA_CLOSE_GOP_SYNC		(0x39e << 2)
#define DA_CLOSE_GOP_FLAG		(0x39f << 2)


/* report status debug info in DMEM */
#define SAVE_DEBUG_REFERENCE_TIMECODE  (0x3b0 << 2)
#define SAVE_DEBUG_OUTPUT_TIMECODE     (0x3b1 << 2)
#define SAVE_DEBUG_PREV_PTYPE          (0x3b2 << 2)
#define SAVE_DEBUG_SEQ_HEADER_PRECEDED (0x3b3 << 2)
#define SAVE_DEBUG_SNR                 (0x3b4 << 2)
#define SAVE_DEBUG_VBV_FULLNESS        (0x3b5 << 2)
#define SAVE_DEBUG_QUANT_VALUE         (0x3b6 << 2)
#define SAVE_DEBUG_BYTES_PREV_PICTURE  (0x3b7 << 2)
#define SAVE_DEBUG_FRAME_NUM           (0x3b8 << 2)
#define SAVE_DEBUG_TOTAL_ENCODED_BITS  (0x3b9 << 2)
#define SAVE_DEBUG_STATUS_READY_SEMAPHORE   (0x3ba << 2)
#define SAVE_DEBUG_NUM_FRAME_STATUS_MISSED  (0x3bb << 2)

/*
 *----------------------------------------------------------------------------
 * Bias locations for MC 0,0 algorithm.  There are separate ones for B frames
 * and P frames.  Lower values produce more 0,0 blocks.
 *----------------------------------------------------------------------------
 */
#define DA_00_ACT_BIAS_PRED	(0x3c0 << 2)
#define DA_00_ACT_BIAS_BIDIR	(0x3c1 << 2)

/*
 *----------------------------------------------------------------------------
 * Activity threshold locations for quant-based, activity-biased intra/non-intra
 * decision.  There are separate ones for B frames and P frames.  If a block's
 * intra activity is below this threshold, it will automatically go intra.
 *----------------------------------------------------------------------------
 */
#define DA_INTRA_THRESH_PRED	(0x3c2 << 2)
#define DA_INTRA_THRESH_BIDIR	(0x3c3 << 2)

/*
 *----------------------------------------------------------------------------
 * Bias locations for QBABID.  If the above activity theshold is violated,
 * the intra activity is then compared to the MC activity to decide between
 * the two.  The bias in the following location, as well as a quant-based bias,
 * is added to the MC activity for the comparison.  Thus, the larger the bias,
 * the more likely a block is to go intra.
 *----------------------------------------------------------------------------
 */
#define DA_INTRA_BIAS_PRED	(0x3c4 << 2)
#define DA_INTRA_BIAS_BIDIR	(0x3c5 << 2)

/*
 *----------------------------------------------------------------------------
 * Location to count how many times video setup was so late that it happened
 * during active video for the next frame, thus causing video tearing from
 * video being captured to the wrong buffer.
 *----------------------------------------------------------------------------
 */
#define DA_TEAR_FRAMES		(0x3c6 << 2)

/* locations for managing video B output banks */
#define DA_OBANK_ENABLE		(0x3d3 << 2)
#define DA_BANK1B_SIZE		(0x3d4 << 2)
#define DA_BANK2B_SIZE		(0x3d5 << 2)


/* PES DATA LOCATION */	
#define DA_PES_DATA			(0x3d6 << 2)

/* PTS REGISTER LOCATION */	
#define DA_PTS_REG_ADDR			(0x3d9 << 2)

/* 
 *----------------------------------------------------------------------------
 * This flag is used to specify the format of PTS
 * if 0 - CL950 compatible
 * if 1 - Thompson compatible
 *
 * NOTE: This is not the same location that is used for this paramter in 601.
 *----------------------------------------------------------------------------
 */
#define DA_PTS_FORMAT   		(0x3da << 2)

/* ACTIVITY BASED INTRA DECISION POINTER */
#define DA_INTRA_ACT                    (0x3dc << 2)

/* AUDIO START REGISTER LOCATION */
#define DA_DUMMY			(0x3dd << 2)
#define DA_AUDIO_START_REG		(0x3de << 2)

/* VIDEO CAPTURE JUNK LOCATIONS */
#define DA_ODD_VACTL_WORD 		(0x3e0 << 2)
#define DA_EVEN_VACTL_WORD		(0x3e1 << 2)
#define DA_CUR_VACTL_WORD 		(0x3e2 << 2)

#define DA_ODD_VIDEO_MB_ROW_INCR 	(0x3e3 << 2)
#define DA_EVEN_VIDEO_MB_ROW_INCR 	(0x3e4 << 2)
#define DA_CUR_VIDEO_MB_ROW_INCR 	(0x3e5 << 2)

#define DA_ODD_FIRST_VIS_OFFSET		(0x3e6 << 2)
#define DA_EVEN_FIRST_VIS_OFFSET	(0x3e7 << 2)

#define DA_ODD_FIELD_JUNK_SKIP		(0x3e8 << 2)
#define DA_EVEN_FIELD_JUNK_SKIP		(0x3e9 << 2)

#define DA_ABS_LINES_INIT_VAL           (0x3ea << 2)
#define DA_FIELD_DADR                   (0x3eb << 2)

#define	DA_POLARITY_SWITCH              (0x3ec << 2)


/* STACK SAVE DMEM LOCATION WHEN ENTERING SLICE */
#define SP_SAVE_DADR		(0x3ee << 2)

/* VIDEO DEBUG POINTER LOCATION Must be in low dmem for single IMEM load*/
#define VID_DEBUG_PTR_LOC	(0x3ef << 2)

/* INPUT DMEM LOCATIONS OVERLAYING LOW INSTRUCTIONS */
/* RATE CONTROL DMEM LOCATIONS */
/* MUST BE LOADED AFTER CODE!!!!! */
#ifndef LOADER
#define I_FRAME_BITS_PER_MB     (0x3f0 << 2)
#define P_FRAME_BITS_PER_MB     (0x3f1 << 2)
#define B_FRAME_BITS_PER_MB     (0x3f2 << 2)
#define BITS_PER_SEC_DIV_400    (0x3f3 << 2)
#define ONE_OVER_VBV_SIZE       (0x3f4 << 2)
#define INIT_VBV_FULLNESS       (0x3f5 << 2)
#define HDR_VBV_SIZE_LOC        (0x3f6 << 2)
#define VBV_DLY_SCALE_LOC       (0x3f7 << 2)
#endif


/* VIDEO LOCATIONS */
#define DA_HAVE_TOKEN           (0x3fb << 2)
#define DA_WAIT_VIDA_RDY        (0x3fc << 2)
#define DA_VIDIN_DST            (0x3fd << 2)
#define DA_VIDIN2_DST           (0x3fe << 2)
#define REFBXF_TBLPTR_DADR      (0x3ff << 2)


#define MAX_VIDEO_BUFFERS       2
#define MAX_SIF_BUFFERS         4
#define MAX_QSIF_BUFFERS        6
#define MAX_STAT_BUFFERS        4
#define MAX_RECON_BUFFERS       2



#define BASE                    (0x9000)

/* @@@@@@@@@@@@@@@@@@ START OF THE BUFFERS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */

#define BUF_START_ADDR			(BASE)

#define DISTANCE			(4)

#define BUF_HDEC_EVEN_SIZE		(18*22*128)
#define BUF_HDEC_ODD_SIZE		(18*22*128)
#define BUF_REF_LUMA_SIZE		(18*22*64)
#define BUF_REF_CHROMA_SIZE		(18*22*32)
#define BUF_SIF_LUMA_SIZE		(18*22*64)
#define BUF_SIF_CHROMA_SIZE		(18*22*32)

#define BUF_QSIF_SIZE			(396*16)

#define QUANT_TABLE_SIZE        (32)
#define NUM_QUANT_TABLES        (32)
#define TOTAL_QUANT_TABLE_SIZE		(QUANT_TABLE_SIZE*NUM_QUANT_TABLES)
/* PP buf size has 2 leading locations with SUM_STAT_TOT and SUM_STAT_MIN */
#define STAT_OFFSET_SIZE		(0x10)
#define BUF_PP_STATS_SIZE		((396*2) + STAT_OFFSET_SIZE)
#define	BITSTREAM_BUF_SIZE		(0x4000)

#define BUF_HDEC_EVEN_1		(BUF_START_ADDR)
#define BUF_REF_LUMA_1		(BUF_HDEC_EVEN_1 + BUF_HDEC_EVEN_SIZE + (64*DISTANCE))
#define BUF_REF_LUMA_2		(BUF_REF_LUMA_1 + BUF_REF_LUMA_SIZE + (64*DISTANCE))

#define BUF_REF_CHROMA_1	(BUF_REF_LUMA_2 + BUF_REF_LUMA_SIZE + (64*DISTANCE))
#define BUF_REF_CHROMA_2	(BUF_REF_CHROMA_1 + BUF_REF_CHROMA_SIZE + (64*DISTANCE))

#define BUF_SIF_LUMA_1		(BUF_REF_CHROMA_2 + BUF_REF_CHROMA_SIZE + (64*DISTANCE))
#define BUF_SIF_LUMA_2		(BUF_SIF_LUMA_1 + BUF_SIF_LUMA_SIZE + (64*DISTANCE))
#define BUF_SIF_LUMA_3		(BUF_SIF_LUMA_2 + BUF_SIF_LUMA_SIZE + (64*DISTANCE))
#define BUF_SIF_LUMA_4		(BUF_SIF_LUMA_3 + BUF_SIF_LUMA_SIZE + (64*DISTANCE))


#define BUF_SIF_CHROMA_1	(BUF_SIF_LUMA_4   + BUF_SIF_LUMA_SIZE + (64*DISTANCE))
#define BUF_SIF_CHROMA_2	(BUF_SIF_CHROMA_1 + BUF_SIF_CHROMA_SIZE + (32*DISTANCE))
#define BUF_SIF_CHROMA_3	(BUF_SIF_CHROMA_2 + BUF_SIF_CHROMA_SIZE + (32*DISTANCE))
#define BUF_SIF_CHROMA_4	(BUF_SIF_CHROMA_3 + BUF_SIF_CHROMA_SIZE + (32*DISTANCE))

 /* DECODER buffers */
#define INPUT_BS_SIZE           (0x2800)
#define QM_SIZE                 (2*32*32)
/*------------------------------------------------*/
/*      DRAM buffers definition (in bytes)        */
/*------------------------------------------------*/
#define         D_BITS_BUF      ((((BUF_SIF_CHROMA_4 + BUF_SIF_CHROMA_SIZE + (32*DISTANCE)) + 0x3ff) & ~0x3ff) << 2)  /* 0x2800 words    */
#define         D_BITS_BUF_VLD	D_BITS_BUF
#if 0
#define         D_RefY_frame1   (D_BITS_BUF + (INPUT_BS_SIZE << 2)) /* 352*288/4 words */
#define         D_RefY_frame2   (D_RefY_frame1)                     /* 352*288/4 words */
#endif

#define         D_RefC_frame1   (D_BITS_BUF + (INPUT_BS_SIZE << 2)) /* 352*288/8 words */
#define         D_RefC_frame2   (D_RefC_frame1)                     /* 352*288/8 words */
#define         D_Vid_frame1    (D_RefC_frame2)                     /* 352*288/2 words*/
#define         D_Vid_frame2    (D_Vid_frame1)                

#define         D_code_dump     (D_Vid_frame2 + (BUF_HDEC_EVEN_SIZE<<2))

#define BUF_END_ADDR		(D_code_dump>>2)

/* @@@@@@@@@@@@@@@@@@ END OF THE BUFFERS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */


#define	BITSTREAM_BASE_ADDR	(0x60000)
#define D_VLC_OUTPUT		(BITSTREAM_BASE_ADDR)


#define	VLC_TABLES		(BITSTREAM_BASE_ADDR + BITSTREAM_BUF_SIZE)
#define VLC_TABLES_SIZE		(0x400)
 
#define	BUF_PP_STATS_1		(VLC_TABLES + VLC_TABLES_SIZE + STAT_OFFSET_SIZE)
#define	BUF_PP_STATS_2		(BUF_PP_STATS_1 + BUF_PP_STATS_SIZE)
#define	BUF_PP_STATS_3		(BUF_PP_STATS_2 + BUF_PP_STATS_SIZE)
#define	BUF_PP_STATS_4		(BUF_PP_STATS_3 + BUF_PP_STATS_SIZE)

#define BUF_QSIF_1		(BUF_PP_STATS_4 + BUF_PP_STATS_SIZE + (16*DISTANCE))
#define BUF_QSIF_2		(BUF_QSIF_1 + BUF_QSIF_SIZE + (16*DISTANCE))
#define BUF_QSIF_3		(BUF_QSIF_2 + BUF_QSIF_SIZE + (16*DISTANCE))
#define BUF_QSIF_4		(BUF_QSIF_3 + BUF_QSIF_SIZE + (16*DISTANCE))
#define BUF_QSIF_5		(BUF_QSIF_4 + BUF_QSIF_SIZE + (16*DISTANCE))
#define BUF_QSIF_6		(BUF_QSIF_5 + BUF_QSIF_SIZE + (16*DISTANCE))

#define	ALT_QUANT_TABLES_INTRA		(BUF_QSIF_6 + BUF_QSIF_SIZE + (16*DISTANCE))
#define	ALT_QUANT_TABLES_NONINTRA	(ALT_QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE)
#define	ALT_DQUANT_TABLES_INTRA		(ALT_QUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE)
#define	ALT_DQUANT_TABLES_NONINTRA	(ALT_DQUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE)

#define DA_F_VBS_VBF           	(ALT_DQUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE)
#define DA_F_VBS_VBF_SIZE	0x200
#define	QUANT_TABLES_INTRA	(DA_F_VBS_VBF + 0x200)
#define	QUANT_TABLES_NONINTRA	(QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE)
#define	DQUANT_TABLES_INTRA	(QUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE)
#define	DQUANT_TABLES_NONINTRA	(DQUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE)
#define	COS_TABLE		(DQUANT_TABLES_NONINTRA+TOTAL_QUANT_TABLE_SIZE)
#define	COS_TABLE_SIZE		(32)

/* 0x10 extra locations for leading frame data struct */
#define	QS_NBS_TABLE		(COS_TABLE + COS_TABLE_SIZE)
#define QP_SIZE                 (800)
#define DA_QP_MASK             	(QS_NBS_TABLE)	/* C-MODEL USES DA_QP_MASK */

#define		HIGH_BASE	(QS_NBS_TABLE + QP_SIZE)
#define		DMA_a0_TABLE	(HIGH_BASE)
#define         DA_ME2          (HIGH_BASE+0x40)
#define		DA_CLIPX	(HIGH_BASE+0x400)
#define		DA_CLIPY	(HIGH_BASE+0x600)
#define 	DA_BTB          (HIGH_BASE+0x1000)
#define 	DA_PTB          (HIGH_BASE+0x1600)
#define		DA_CLIPX_SIZE	0x200
#define		DA_CLIPY_SIZE	0xA00
#define 	DA_BTB_SIZE     0x600
#define 	DA_PTB_SIZE     0x600

#define PTABLE_ADDRESS		(DA_PTB + 0x600)	
#define PTABLE_SIZE		(64)	

#define	MQUANT_OFFSET_TABLE	(PTABLE_ADDRESS + PTABLE_SIZE)
#define	D_MQUANT_TABLE		(MQUANT_OFFSET_TABLE)
#define	MQUANT_OFFSET_TABLE_SIZE	(396)		

#define	ME1_CLIP_TABLE_SIZE	(792) 
#define	ME1_CLIP_TABLE_B	(MQUANT_OFFSET_TABLE +MQUANT_OFFSET_TABLE_SIZE) 
#define	ME1_CLIP_TABLE_P	(ME1_CLIP_TABLE_B + ME1_CLIP_TABLE_SIZE) 

#define	BUF_PIC_DATA_SIZE		258

#define	BUF_PIC_DATA_1		(ME1_CLIP_TABLE_P + ME1_CLIP_TABLE_SIZE + 8)
#define	BUF_PIC_DATA_2		(BUF_PIC_DATA_1 + BUF_PIC_DATA_SIZE)
#define	BUF_PIC_DATA_3		(BUF_PIC_DATA_2 + BUF_PIC_DATA_SIZE)
#define	BUF_PIC_DATA_4		(BUF_PIC_DATA_3 + BUF_PIC_DATA_SIZE)
#define	BUF_PIC_DATA_5		(BUF_PIC_DATA_4 + BUF_PIC_DATA_SIZE)
#define	BUF_PIC_DATA_6		(BUF_PIC_DATA_5 + BUF_PIC_DATA_SIZE)

#define	BUF_REPORT_DATA_SIZE		2

#define	BUF_REPORT_DATA_1	(BUF_PIC_DATA_6 + BUF_PIC_DATA_SIZE)
#define	BUF_REPORT_DATA_2	(BUF_REPORT_DATA_1 + BUF_REPORT_DATA_SIZE)
#define	BUF_REPORT_DATA_3	(BUF_REPORT_DATA_2 + BUF_REPORT_DATA_SIZE)
#define	BUF_REPORT_DATA_4	(BUF_REPORT_DATA_3 + BUF_REPORT_DATA_SIZE)
#define	BUF_REPORT_DATA_5	(BUF_REPORT_DATA_4 + BUF_REPORT_DATA_SIZE)
#define	BUF_REPORT_DATA_6	(BUF_REPORT_DATA_5 + BUF_REPORT_DATA_SIZE)

#define	BUF_STARTGOP_DATA_SIZE		3

#define	BUF_STARTGOP_DATA_1	(BUF_REPORT_DATA_6 + BUF_REPORT_DATA_SIZE)
#define	BUF_STARTGOP_DATA_2	(BUF_STARTGOP_DATA_1 + BUF_STARTGOP_DATA_SIZE)
#define	BUF_STARTGOP_DATA_3	(BUF_STARTGOP_DATA_2 + BUF_STARTGOP_DATA_SIZE)
#define	BUF_STARTGOP_DATA_4	(BUF_STARTGOP_DATA_3 + BUF_STARTGOP_DATA_SIZE)
#define	BUF_STARTGOP_DATA_5	(BUF_STARTGOP_DATA_4 + BUF_STARTGOP_DATA_SIZE)
#define	BUF_STARTGOP_DATA_6	(BUF_STARTGOP_DATA_5 + BUF_STARTGOP_DATA_SIZE)

#define         D_COS_Tbl       (COS_TABLE<<2)  /* share with the encoder */
#define         D_IQM_Tbls      ((BUF_STARTGOP_DATA_6 + BUF_STARTGOP_DATA_SIZE) << 2)  /* 32*31=992 words */
#define         D_QM_VBase      (D_IQM_Tbls - (2*32 << 2))          /* virtual address */
#define         D_NQM_Tbls      (D_IQM_Tbls + (32 << 2))            /* 32*31=992 words */
#define         D_QMShift_Tbl   (D_QM_VBase + (QM_SIZE<<2))         /* 32 words        */
#define         D_RefY_frame1   (((D_QMShift_Tbl + (QM_SIZE<<2)) + 0xff ) & ~0xff)   /* for deblocking */
#define         D_RefY_frame2   (D_RefY_frame1)
#define         end_recoder     (D_RefY_frame2 + (BUF_SIF_LUMA_SIZE<<2))


#define D_TRASH                	0x7FD00

/*  VLC Table DRAM Addresses  */
 
#define VLC_TBL_H    (VLC_TABLES>>14)         /* High_order 16 bits of VLC_Table address. */
#define MBA_TBL      0x0         /* Low 16 bits of VLC_Table addresses. */
#define MTYPE_P_TBL  0x24
#define MTYPE_B_TBL  0x2C
#define CBP_TBL      0x3C
#define MV_TBL       0x7C
#define DC_L_TBL     0xAD
#define DC_C_TBL     0x1AD
#define MTYPE_I_TBL  0x2AD
/* *******  David and Tom's Buffer Definitions ************** */

#define D_LUMA_601_E			BUF_HDEC_EVEN_1	
#define D_LUMA_601_O			BUF_HDEC_EVEN_1	
#define D_LUMA_SIF_PREV			BUF_SIF_LUMA_1
#define D_LUMA_SIF_OUT			BUF_SIF_LUMA_2
#define D_CHROMA_SIF_OUT		BUF_SIF_CHROMA_1
#define D_LUMA_QSIF_OUT			BUF_QSIF_1
#define D_LUMA_CURR			BUF_SIF_LUMA_3
#define D_CH_CURR			BUF_SIF_CHROMA_2
#define D_LUMA_FWD_REF			BUF_REF_LUMA_1
#define D_LUMA_BWD_REF			BUF_REF_LUMA_2
#define D_CH_FWD_REF			BUF_REF_CHROMA_1
#define D_CH_BWD_REF			BUF_REF_CHROMA_2
#define D_QSIF_CURR			BUF_QSIF_2
#define D_QSIF_FWD_REF			BUF_QSIF_3
#define D_QSIF_BWD_REF			BUF_QSIF_4
#define D_LUMA_RECON_OUT		BUF_REF_LUMA_2
#define D_CHROMA_RECON_OUT		BUF_REF_CHROMA_2
#define BIT_BUFFER			BITSTREAM_BASE_ADDR

#define D_LUMA_601_PREV			D_LUMA_SIF_PREV
#define D_QSIF_REF			D_QSIF_FWD_REF

#define D_ME1_CLIP_TABLE_B		ME1_CLIP_TABLE_B
#define D_QUANT_TABLES_INTRA		QUANT_TABLES_INTRA
#define D_QUANT_TABLES_NONINTRA		QUANT_TABLES_NONINTRA

#define D_F_VBF_VBS_PTR			DA_F_VBS_VBF

/* *************************************************** */
 

