/*	@(#)scorp_def.h	1.21	1/3/94	*/
/*************************************************************************
 *
 * C-Cube Microsystems
 *
 *************************************************************************/

/*************************************************************************
 *
 * Filename:  scorp_def.h
 * Author:  Stewart Kelly
 * Purpose:  Scorpio device definitions, internal and externally useful
 * Date:  9/28/92
 *
 *************************************************************************/

/*
 * number of 4000 positions and offset of first chip
 * in local bus address map
 */
#define	NUM_4000		14
#define	FIRST_4000_NUM		2
#define	MAX_NUM_SCORPIO		4

/*
 * definition of base address and size of address space
 * for the CL4000s
 */
#define	CL4000_ADDR_SZ		0x01000000
#define	CL4000_ADDR_BASE	(0xf0000000 + (FIRST_4000_NUM * CL4000_ADDR_SZ))

/*
 * miscellaneous register mask and bit number defs
 */
#define	IVR_MASK		0x000000ff
#define	LBUS_ERR_MASK		0x00000200
#define	IPL_MASK		0x0000e000
#define	FIFO_OUFLOW_MASK	0x00000100
#define	FIFO_FLOOR		512
#define	IVR_SHIFT		0
#define	IPL_SHIFT		13

/*
 * uses of 3 interrupt enable bits
 */
#define	SCV_INT1	0x00000400
#define	SCV_INT2	0x00000800
#define	SCV_INT3	0x00001000

/*
 * defines for dram_mode field of Scorpio struct
 */
#define	DRAM_INTLVD_BIT		0x4
#define	DRAM_INTLVD		0x0
#define	DRAM_PAGE_BITS		0x3
#define	DRAM_8x10		0
#define	DRAM_9x9		1
#define	DRAM_10x8		2

#define	MODE_AUD_START		0x8
#define	MODE_FAUXE_DIS		0x10

/*************************************************************************
 *
 * C-Cube Microsystems
 *
 *************************************************************************/
