#include "stdincs.h"

#ifdef VTOOLSD
extern "C" {
#include <vtoolsc.h>
}
#else
#include <stdlib.h>
#endif
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include "dtdefs.h"
#include "stdio.h"
#include "vt_acc.h"
#include "vt_regs.h"
#include "vt_vrp.h"
#include "4000_reg.h"
#include "ic_dmm.h"
#include "4100_ld.h"
#include "4100_api.h"
#include "mcode.h"
#include "capture.h"
#include "math.h"


CCapture::CCapture(DEVSTRUCT *dwDevice) :CMicrocode(dwDevice) 
{
	PhysBuffer=NULL;
}

static int pts_reg_value   = PTS_DISABLED;
static int scr_reg_value   = PTS_DISABLED;
static int as_reg_value    = DA_DUMMY;
static int int_area_value  = 0;
static int freq_filt_enable = 0;

ECODE CCapture::Load()
{
	//PREGS Regs=GET_STRUCT_PTR(Dev);
 // PREGS Regs;
  uwide temp36;
  VT_ResetVRP(Dev); 
  VT_ResetVRP(Dev); 
  

    
    /* reset chip & clear IMEM - set up for initialization sequence */
    
    reset(Regs);
    imemClear(Regs);
    
    imemWrite(Regs,0x10,0x8c0);
    run_inst(Regs,32);
    imemWrite(Regs,0x10,0);
    reset(Regs);
    smemClear(Regs);
    
    /*  Enable DMA Unit (Normal, Interleaved, Refr Count = 0x100). */
    GBusWrite(GBUS_DMAMODE,VIDTOOL_MEMCONFIG); 
    
    /*  Reset Vlc_Start register. */
    GBusWrite(GBUS_VLCSTART,0x0);
    
    /*  Reset then turn On VLC Unit (MPEG, Intra, empty PACK & ZZ). */
    GBusWrite(GBUS_VLCCTL,0x00080105);
    GBusWrite(GBUS_VLCCTL,0xc0080105);

    /*  Enable CPU module (reset Ghalt, Greset), set PIO as input. */
    WBusWrite(Regs,WBUS_CPUCTL,0xc0000000);
    
    /*  Dummy VLD transfer to disable VLD. */
    WBusWrite(Regs,WBUS_CHMEM5,0x07840002);
    
    /*
     * set a breakpoint
     * run for awhile to initialize the VLD
     * then reset the chip. 
     */
    GBusWrite(0x24,0x20);
    GBusWrite(0x24,0x0);
    
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);

    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    

    /*  VLD initialized: start again. */
    reset(Regs);                             

    rmemClear(Regs);
#if 0
    if(dmem_clr == TRUE) {
      dramClear(Regs);
    }
#endif   
	// Init board here ?	
    
    /* initialize rmem locations - MUST BE DONE BEFORE INITIALIZING IMEM! */
    
    temp36.loword = 0xc00000;
    temp36.hiword = 0;
    rmemWrite(Regs,22,&temp36);
    CpuWritePC(Regs, 0, 0, 0);

    temp36.loword = 0x800000;
    temp36.hiword = 0;
    rmemWrite(Regs,23,&temp36);
    CpuWritePC(Regs, 0, 0, 0);

    temp36.loword = 0;
    temp36.hiword = 0;
    rmemWrite(Regs,30,&temp36);
    CpuWritePC(Regs, 0, 0, 0);
    
    /* Initialize initial DMEM image */
    //VT_LoadFile(Dev,VR_DRAM,"ic.dmb");
    /* printf("loading %s in dram # %d\n",dmem_file,chip); */
    
    /* Initialize initial IMEM image */
    //VT_LoadFile(Dev,VR_IMEM,"ic.imb");
   ReturnIfError(LoadMicrocode("ic.dmb"));
   /* printf("loading %s in imem # %d\n",imem_file,Regs); */
     
    /* load the number of VHS lines to blackout */
    dramWrite(Regs, DA_VCR_BLANK >> 2, Dev->CaptureInfo.Blanklines);
   
    /* Load the Tables and do the remainder of the initialization.  If SIF 
       resolution, make sure to initialize the rc and bitrate parameters! */
    
    init_SIF();   

    /*  set the chipid */    
    GBusWrite(GBUS_HCTL,0x50001000 | (CHIP_ID << 4));
    
    /* start the chip executing */
    
	GBusWrite(GBUS_HCTL,0xf0000000);
	Sleep(10);
  // if pal inputs 
	DWORD data[2];
    if (Dev->CurrentVideoMode == PAL) 
	{
		/*---------------------------------------------------------
		 *  Set the encoder mode to PAL
		 *---------------------------------------------------------*/
		data[0] = 6;  /* Video Input Mode */
		data[1] = 7;  /* PAL 710x576 input */ 

		ReturnIfError(LoadParams(TC_NOW, 2, 2, data));
		/* 
		 * The SetDefaultValues command sets the bitrate to the default
		 * so we need to reset it to the desired value
		 */

		data[0] = 1;  /* Bit rate */
		data[1] = Dev->CaptureInfo.DataRate/400;;  /* new bitrate*/ 
		ReturnIfError(Dev->MicroCode->LoadParams(TC_NOW, 3, 2, data));
		//sleep(1);
	}
	// set Gop size 1
	data[0]=1;
	data[1]=1;

  ReturnIfError(Dev->MicroCode->LoadParams(TC_NOW, 5, 2, data));
	// disable stuffing
	data[0]=5;
	data[1]=0;

  ReturnIfError(LoadParams(TC_NOW, 3, 2, data));
// FIXED QUANT
	if (Dev->CaptureInfo.FixedQuant)
	{
		data[0]=4;
		// vee model quality.vee
		data[1]=(int)CalcQuant(Dev->CaptureInfo.Quality); 

		ReturnIfError(LoadParams(TC_NOW, 3, 2, data));
	}
	if (Dev->CaptureInfo.ShiftUp!=0)
	{
		data[0]=3;
		data[1]=(DWORD)(-Dev->CaptureInfo.ShiftUp);

		ReturnIfError(LoadParams(TC_NOW, 2, 2, data));
	}

	return(VT_NO_ERROR);
}

/***********************************************************************
 *
 * initialize CL4000 array for SIF processing.
 *
 ***********************************************************************/
//#pragma optimize( "", off )

 
 ECODE CCapture::init_SIF()

{
	PREGS Regs=GET_STRUCT_PTR(Dev);
    int bps_scaled, bits_per_frame, vbv_delay, i;
/* initialize areas in DRAM */

    /* Load default q matrix */
    VT_LoadFileBin(Dev, VR_DRAM,"qtab.bii",  QUANT_TABLES_INTRA, QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);

  /* for low bitrate operation this should be done using loadQmatrix() */
#if 0
  if (bitrate < 6000000.0) {
    if(freq_filt_enable)
      VT_LoadFile_bin(Dev, VR_DRAM,"qtab_5F.bii", QUANT_TABLES_INTRA, QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);
    else  
     VT_LoadFile_bin(Dev, VR_DRAM,"qtab_5.bii",  QUANT_TABLES_INTRA, QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);
  }
#endif

    VT_LoadFileBin(Dev, VR_DRAM,"cos_tbl.bii",  COS_TABLE, COS_TABLE + 32 - 1, 0);
    VT_LoadFileBin(Dev, VR_DRAM,"vlc_tbl.bii",  VLC_TABLES, VLC_TABLES + 0x2c0 - 1, 0);
    VT_LoadFileBin(Dev, VR_DRAM,"f_vbfvbs.bii", DA_F_VBS_VBF, DA_F_VBS_VBF + 0x200 - 1, 0);


/* write bitrate parameters into DRAM  - MUST be done after code is loaded! */

    bps_scaled = Dev->CaptureInfo.DataRate/400;
														//note framerate should be 29.97
    bits_per_frame = Dev->CaptureInfo.DataRate *100 / Dev->CaptureInfo.FrameRate ;
    vbv_delay = 943718400 / (Dev->CaptureInfo.DataRate/100);

    dramWrite(Regs , BITS_PER_SEC_DIV_400 >> 2 , bps_scaled);
    dramWrite(Regs , ONE_OVER_VBV_SIZE >> 2    , VBV_RECIP);
    dramWrite(Regs , INIT_VBV_FULLNESS >> 2    , INIT_VBV_FULLVAL);
    dramWrite(Regs , HDR_VBV_SIZE_LOC >> 2     , VBV_SIZE);
    dramWrite(Regs , VBV_DLY_SCALE_LOC >> 2    , vbv_delay);
    dramWrite(Regs , AVG_BITS_PER_FRAME >> 2   , bits_per_frame);


    /* Initialize the interrupt enable locations */
    for (i=0; i< INT_AREA_SIZE; i++)
     dramWrite(Regs , (INT_AREA + i), int_area_value);

    /* Setup Memory locations for scr register */
    dramWrite(Regs , DA_SCR_REG_ADDR>>2, scr_reg_value); 

    /* Setup Memory locations for audio_start_register */
    dramWrite(Regs , DA_AUDIO_START_REG>>2, as_reg_value); 

    /* Setup Memory location for pts register */
    dramWrite(Regs , DA_PTS_REG_ADDR>>2, pts_reg_value); 

   /* Setup Memory location for wide video A register */
   // if (wide_vida_flag)
       dramWrite(Regs, DA_VIDA_BUS_WIDTH >> 2, 0x10);
    //else
    //   dramWrite(chipNo, DA_VIDA_BUS_WIDTH >> 2, 0x0);

    /* Setup Memory location for wide video B register */
    //if (wide_vidb_flag)
       dramWrite(Regs, DA_VIDB_BUS_WIDTH >> 2, 0x10);
    //else
    //   dramWrite(chipNo, DA_VIDB_BUS_WIDTH >> 2, 0x0);


    /* Initialize ME MemCtl */
    GBusWrite(GBUS_MEMEMCTL,0xc0000040);    

    /* Clear Host semaphore bit */
    GBusWrite(GBUS_SEMA,0x0);               
   
    /* Disable all INTs. */    
    WBusWrite(Regs,WBUS_INTCTL,0xfffefffe);      
   
    /* Reset Mul_Cntl Reg (clip 9) */
    WBusWrite(Regs,WBUS_MULCTL,0x4);             
    

     dramWrite(Regs , DA_FEATURE_FLAGS >> 2, 0); 
   
	/*
     * Enable DMA Unit 
     * (Normal, Interleaved, 8 or 9-bit page, Refr Count = 0x100) 
     */
      //GBusWrite(GBUS_DMAMODE,0xc9000000 | DMA_MODE_9_CHP); 
      GBusWrite(GBUS_DMAMODE,VIDTOOL_MEMCONFIG); 

/* use Scorpio dma_mode configuration */

    /*-------------------------------------------------------------
     *  Configure dma_mode register of VRP to set memory type 
     *  8x10, 9x9, 10x8, memory organization (interleaved), and
     *  refresh count = 0x100.
     *  This code reads the SCV register of the
     *  scorpio/jupiter board to determine dram type and sets VRP
     *  accordingly.  Note customers can hard-code this if necessary.
     */
    /*-------------------------------------------------------------*/
	DWORD tmp;
    /* on Scorpio do not allow output bank switching mode */
    dramRead(Regs , DA_FEATURE_FLAGS >> 2, &tmp);
    tmp = tmp & (~FEATURE_OBANK_ENABLE);
    dramWrite(Regs , DA_FEATURE_FLAGS >> 2, tmp);

    /* set obits field selection flag */
    dramRead(Regs , DA_FEATURE_FLAGS >> 2, &tmp); 
    tmp = tmp  | FEATURE_OBITS_FIELD;	/* this sets obits 2nd field output */
    dramWrite(Regs , DA_FEATURE_FLAGS >> 2, tmp); 

    dramWrite(Regs , DA_BANK1B_SIZE >> 2, 0); 
    dramWrite(Regs , DA_BANK2B_SIZE >> 2, 0); 

	
    /* Reset Vlc_Start register. */
    GBusWrite(GBUS_VLCSTART,0x0);

    /* turn on VLC unit (MPEG, Intra, empty PACK & ZZ) */
    GBusWrite(GBUS_VLCCTL,0x00080105);
    GBusWrite(GBUS_VLCCTL,0xc0080105);

    /* Zero out VLC Pack register, 
     * enable CPU module (reset Ghalt, Greset), set PIO as input, 
     */
    WBusWrite(Regs,WBUS_CPUPACK,0x0);
    WBusWrite(Regs,WBUS_CPUCTL,0xc0000000);

    /* enable smem, refresh and VLC */
    WBusWrite(Regs,WBUS_INTCTL,0x00010201);
 
    /* setup VLC DMA */
    WBusWrite(Regs,WBUS_CHMEM5,0xff900003); 
	return (VT_NO_ERROR);
}

//#pragma optimize( "", on ) 


ECODE CCapture::Start()
{
	double ActSize;

	if (!Dev->Busy)
	{

		CrChange(Dev->Regs,CTRL1,0xff,0x10); // change later to mask in bit 1 to not kill pasthrough
		Dev->Regs->Csr=Dev->Regs->Csr & ~MSTR_MODE_MASK ; // CLEAR MASTER
		VT_SetupFifo(Dev,70,8);  // reset fifo
	//	CrPoke(Dev->Regs,CTRL2,FIFO_MODE_PROGRAM|FIFO_LD);
	//	CrPoke(Dev->Regs,CTRL2,FIFO_MODE_PROGRAM|FIFO_LD|FIFO_RESET);
	//	CrPoke(Dev->Regs,CTRL2,0);
	//	if (PhysBuffer!=NULL)
	//		VT_LoadDma(Dev,2,m_Size*sizeof(DWORD),PhysBuffer);
		// dma init ??
	//	Dev->Regs->Csr=Dev->Regs->Csr & ~MSTR_MODE_MASK | MSTR_TOGGLE; // Toggle mode
		Dev->Regs->Csr=Dev->Regs->Csr & ~MSTR_MODE_MASK  | MSTR_OUTPUT; // No passthru
	//	CrChange(Dev->Regs,CTRL2,FIFO_MODE_MASK,FIFO_MODE_ICAPTURE);
		CrChange(Dev->Regs,CTRL2,FIFO_MODE_MASK,FIFO_MODE_IONLY);
		ActSize=((double)Dev->CaptureInfo.DataRate /(.32* Dev->CaptureInfo.FrameRate));
		FrameSize=(DWORD)(ActSize*0.8) & 0xfffffff0;
		MaxFrameSize=(DWORD)(ActSize*1.2) & 0xfffffff0;
//		m_WriteLoc=0;
//		m_ReadLoc=0;
		FrameNumber=0;
		Stopping=FALSE;
	//	CrChange(Dev->Regs,CTRL1,0xff,0x11); // change later to mask in bit 1 to not kill pasthrough
		Dev->Busy=TRUE;
	}
	return CMicrocode::Start();
}


ECODE CCapture::Stop()
{
	Stopping=TRUE;
	return CMicrocode::Stop();

}



ECODE CCapture::SetParam(DWORD param,long  value)
{
	PREGS bd_addr=GET_STRUCT_PTR(Dev);
	DWORD uvalue=(DWORD)value;
	DWORD data[4];	
	switch (param)
	{

	case PASSMODE:   
		if (Dev->Busy) return VT_ERR_HW_BUSY;

	case DATARATE:	 
		data[0] = 1;  /* Bit rate */
		data[1] = value/400;;  /* new bitrate*/ 
		ReturnIfError(Dev->MicroCode->LoadParams(TC_NOW, 3, 2, data));
		break;
	case QUALITY: 	 
		data[0]=4;
		// vee model quality.vee
		data[1]=(int)CalcQuant(value); 

		ReturnIfError(LoadParams(TC_NOW, 3, 2, data));
		break;
	case PADDING: 	 
		data[0]=5;
		data[1]=value;
		ReturnIfError(LoadParams(TC_NOW, 3, 2, data));
		break;
	case HUE:
 		Dev->VipRegs.VipHueCtrl=value;
		if (Dev->VipRegs.VipVer>0)
 			Dev->WriteVIP(VIP_HUE_CTRL, &uvalue, 1);	     
		else
			Dev->WriteVIP(0, &uvalue, 1);// Bug in version 1	     
		break;
	case SATURATION: 
 		Dev->VipRegs.VipSatCtrl=value;
 		Dev->WriteVIP(VIP_SAT_CTRL, &uvalue, 1);	     
		break;
	case INTENSITY:	 
 		Dev->VipRegs.VipBrightCtrl=value;
 		Dev->WriteVIP(VIP_BRIGHT_CTRL, &uvalue, 1);	     
		break;
	case CONTRAST:	 
 		Dev->VipRegs.VipContCtrl=value;
 		Dev->WriteVIP(VIP_CONT_CTRL, &uvalue, 1);	     
		break;
	case SOURCEISVCR:
	case SHIFTLEFT:
		dprintf("Shift Left set to %d\n",value);
		if (Dev->CurrentVideoMode == PAL)
		{
			Dev->VipRegs.VipHsb=0xD8-value>>2;
 			Dev->WriteVIP(VIP_HSB, &(Dev->VipRegs.VipHsb), 1);
		}
		else
		{
			Dev->VipRegs.VipHsb=0xDB-value>>2;
 			Dev->WriteVIP(VIP_HSB, &(Dev->VipRegs.VipHsb), 1);
		}
		break;
	case SHIFTUP:
	dprintf("Shift Up set to %d\n",value);
	if (Dev->CaptureInfo.ShiftUp!=0)
	{
		data[0]=3;
		data[1]=(DWORD)(-value);

		ReturnIfError(LoadParams(TC_NOW, 2, 2, data));
		break;
	}
		
	case BLANKLINES: 
    /* load the number of VHS lines to blackout */
		dramWrite(bd_addr, DA_VCR_BLANK >> 2, value);
		break;
	case FILTERVALUE:
		Dev->CaptureInfo.FilterValue=(short)value;
		Dev->SetVipFilterMode(TRUE);
		break;
	default: 
		return VT_ERR_HW_BUSY;
	}
	return VT_NO_ERROR;
}


#if 0
  

int CircBuffer::FreeSpace()
{
	if (m_ReadLoc<m_WriteLoc)
	{
		return m_Size-(m_WriteLoc-m_ReadLoc);
	}
	else
		return (m_ReadLoc-m_WriteLoc);
}
/*
CircBuffer::CircBuffer(CBT *Buffer,DWORD Size)
{
	m_Buffer=Buffer;
	m_Size=Size;
	m_ReadLoc=0;
	m_WriteLoc=0;
}
*/
CircBuffer::CircBuffer()
{
	m_Buffer=0;
	m_Size=0;
	m_ReadLoc=0;
	m_WriteLoc=0;
}



#define SEQ_HEADER 0XB3010000

// Must currently be Called after Setting dataRate
ECODE CCapture::InitCircBuffer(DWORD PhysAddr,void *LinAddr,DWORD Size)
{
	m_Buffer=(DWORD*)LinAddr;
	m_Size=Size/sizeof(CBT);
	PhysBuffer=PhysAddr;
	// Framesize=.95 * (bitrate/8) / FramesPerSec
	//				
	return (VT_NO_ERROR);
}

ECODE VT_INTERFACE VT_InitCircBuffer(DEVID dwDevice,DWORD PhysAddr,void *LinAddr,DWORD Size)
{
	return (((CCapture*)dwDevice->MicroCode)->InitCircBuffer(PhysAddr,LinAddr, Size));
}



DWORD *FindStart(DWORD *ptr,DWORD size)
{
	DWORD *np=ptr;
	while (np<ptr+size)
	{
		if (*np==SEQ_HEADER)
		{
			return (np);
		}
		np+=64/sizeof(*np);  // c-cube allignes the data
//		np++;
	}
	return NULL;
}

DWORD *FindStart1(DWORD *ptr,DWORD size)
{
	DWORD *np=ptr;
	while (np<ptr+size)
	{
		if (*np==SEQ_HEADER)
		{
			return (np);
		}
		np++;  // Looking for real start
	}
	return NULL;
}
//#pragma optimize( "", on )
#pragma optimize( "", off )


// (m_ReadLoc<=m_WriteLoc ? m_WriteLoc-m_ReadLoc :m_Size-m_ReadLoc); }
DWORD VT_INTERFACE VT_ExtractNextFrame(DEVID dwDevice,void* *pStart)
{
	return (((CCapture*)dwDevice->MicroCode)->ExtractNextFrame(pStart));
}

DWORD CCapture::ExtractNextFrame(void* *pStart)
{
	DWORD tmp;
	DWORD *ptr,*ptr2;
	int i;
	*pStart=NULL;
	VT_GetCurrentTransferAddress(Dev,2,&tmp);
	m_WriteLoc=(tmp-PhysBuffer)/sizeof(CBT);
	if ( FrameSize > ValidData()) 
		return NULL;
	ptr=&m_Buffer[m_ReadLoc];
	if ( (*pStart=(PUCHAR)FindStart1(ptr,MaxRead()))==NULL 
		&& (MaxRead()<ValidData() ))
		// this code should never be true
	{
			m_ReadLoc=0;
			ptr=m_Buffer;
			*pStart=(PUCHAR)FindStart1(ptr,MaxRead());
	}
	if (*pStart==NULL)
		return (0);
	// now find next start
	m_ReadLoc=((DWORD *)*pStart-m_Buffer);
	int NewValid=ValidData();

	if ( FrameSize > NewValid) 
		return NULL;
	if (NewValid>MaxFrameSize)
		NewValid=MaxFrameSize;
//	ptr=(DWORD *)pStart+FrameSize;
	ptr+=FrameSize;
	if (ptr>m_Buffer+m_Size)
	{
		ptr-=m_Size;
		ptr2=FindStart(ptr,NewValid-FrameSize);
	}
	else
	{
		if (MaxRead()<NewValid)
		{   // must do twice
			ptr2=FindStart(ptr,MaxRead()-FrameSize);
			if (ptr2==NULL)
			{
				ptr=m_Buffer;
				ptr2=FindStart(ptr,NewValid-MaxRead());
			}
		}
		else
			ptr2=FindStart(ptr,NewValid-FrameSize);
	}
	if (ptr2!=NULL)
	{
		m_ReadLoc=ptr2-m_Buffer;
//		**(DWORD**)pStart=FrameNumber++;
		return (PtrDiff((CBT*)*pStart,ptr2));
	}
	else 
	{
		if (NewValid==MaxFrameSize)
		{
			m_ReadLoc++;  // Drop this frame
			FrameNumber++;
			return 0xffffffff;
		}
		else
			return NULL;
	}
}
#endif
