// CaptureCompression.cpp : implementation file
//

#include "stdafx.h"
#include "bwdialog.h"
#include "CaptureCompression.h"
#include "Encdlg.h"

#include "afxpriv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CCaptureCompression property page

IMPLEMENT_DYNCREATE(CCaptureCompression, CPropertyPage)

void CCaptureCompression::SetModified(BOOL bChanged)
{
	m_bChanged = bChanged;  
	CPropertyPage::SetModified( bChanged );
}

CCaptureCompression::CCaptureCompression() : CPropertyPage(CCaptureCompression::IDD)
{
	//{{AFX_DATA_INIT(CCaptureCompression)


		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_psp.dwFlags |= PSP_HASHELP;
	m_bChanged = FALSE;
}

CCaptureCompression::~CCaptureCompression()
{
}

void CCaptureCompression::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureCompression)
	DDX_Control(pDX, IDC_CAPTURE_SIZE, m_edDiskSpace);
	DDX_Control(pDX, IDC_CAPTURE_TARGET, m_CaptureTarget);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCaptureCompression, CPropertyPage)
	//{{AFX_MSG_MAP(CCaptureCompression)
	ON_BN_CLICKED(IDC_CAPTURE_ADVANCED, OnCaptureAdvanced)
	ON_CBN_SELCHANGE(IDC_CAPTURE_TARGET, OnSelchangeCaptureTarget)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCaptureCompression message handlers

BOOL CCaptureCompression::OnInitDialog() 
{

	CPropertyPage::OnInitDialog();

	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	
	// Load up the combo box with all the Targets
	CString Target,m_iniFile;
	int loop=1;

	// create the path to  the ini file
	BW_GetMpegIniFileName (m_iniFile.GetBufferSetLength(MAX_PATH),MAX_PATH-1);

	m_iniFile.ReleaseBuffer();
	
	Target.Empty();

	m_CaptureTarget.ResetContent();
	/* verify the playback target exists */
	do {
		TCHAR t1[10]="Type",t2[10];
		strcat(t1,itoa(loop++,t2,10));

		GetPrivateProfileString("RecodeTypes",t1,"",Target.GetBufferSetLength(80),79,m_iniFile);

		if (Target != "")
			m_CaptureTarget.AddString(Target);

		Target.ReleaseBuffer();

		printf("Target %d is %s\n",loop,LPCSTR(Target));

	} while (Target != "");

	GetPrivateProfileString("RecodeTypes","Type1","Default",Target.GetBufferSetLength(80),79,m_iniFile);
	m_CaptureTarget.SelectString( 0,Target );
	Target.ReleaseBuffer();

	char tmp[80];

	m_CaptureTarget.SelectString( 0,pApp->m_Settings.EncodeType() ); 
	sprintf (tmp, "%.1f", BW_EncodeRateToMBm(pApp->m_Settings.CompressionEstimate()));
	m_edDiskSpace.SetWindowText(tmp);

	//save the current encode type so we can restore it on cancel
	m_OldEncodeType = pApp->m_Settings.EncodeType();

	// we need to remember the settings for each playback target in
	// case the user hits cancel!!!

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCaptureCompression::OnCaptureAdvanced() 
{
	int status;

	CWnd *pParentWnd = (CWnd *)AfxGetMainWnd();
   	CEncodeDialog encodeDialog(pParentWnd);

	// Show the advanved compression options page
	encodeDialog.SetCaptureTarget(TRUE);
	status = encodeDialog.DoModal();

	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	m_CaptureTarget.SelectString( 0,pApp->m_Settings.EncodePlayBackTarget() ); 

	char tmp[80];

	sprintf (tmp, "%.1f", BW_EncodeRateToMBm(pApp->m_Settings.CompressionEstimate()));
	m_edDiskSpace.SetWindowText(tmp);
}


void CCaptureCompression::OnSelchangeCaptureTarget() 
{
	// Read which one was selected
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	CString Target;
	m_CaptureTarget.GetLBText(m_CaptureTarget.GetCurSel(),Target);

	// Override the current settings with the last entered for this target
	pApp->m_Settings.ReadEncodeType(Target);

	char tmp[80];

	sprintf (tmp, "%.1f", BW_EncodeRateToMBm(pApp->m_Settings.CompressionEstimate()));
	m_edDiskSpace.SetWindowText(tmp);

	SetModified( TRUE );
}

void CCaptureCompression::OnOK() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	if (m_bChanged)
	{
		m_OldEncodeType = pApp->m_Settings.EncodePlayBackTarget();
		SetModified( FALSE );
	}

	CPropertyPage::OnOK();
}

void CCaptureCompression::OnCancel() 
{
	// restore the original settings
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	pApp->m_Settings.ReadEncodeType(m_OldEncodeType);

	CPropertyPage::OnCancel();
}

//xxxxx this was added 
LRESULT CCaptureCompression::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	//TODO: Add your specialized code here and/or call the base class
	if (message == WM_HELP)	{
		HELPINFO* pHelpInfo = (HELPINFO*) lParam;
		OnHelpInfo(pHelpInfo);
		return TRUE;
	} else if (message == WM_COMMAND)	{
		if (wParam == ID_HELP) {
			HELPINFO HelpInfo;

			HelpInfo.iContextType = HELPINFO_WINDOW;
			HelpInfo.iCtrlId = IDC_CAPTURE_OPTIONS;
			OnHelpInfo(&HelpInfo);
			return TRUE;
		}
	} 

	return CDialog::WindowProc(message, wParam, lParam);
}


BOOL CCaptureCompression::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if ( pHelpInfo->iContextType==HELPINFO_WINDOW )
	{
		long lParam = pHelpInfo->iCtrlId + HIDC_MYBASE;
    	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
    	CWnd* pMainWnd = this;

	    //return global app help mode state to FALSE (backward compatibility)
	    pApp->m_bHelpMode = FALSE;
	    pMainWnd->PostMessage(WM_KICKIDLE); //trigger idle update

	    pMainWnd->WinHelp(lParam, HELP_CONTEXT);
	}
	return TRUE;
}

LRESULT CCaptureCompression::OnCommandHelp( WPARAM, LPARAM lParam )
{
    int nCtrlID = GetFocus()->GetDlgCtrlID(); //Get the ID of the control with the current focus

	lParam = nCtrlID + HIDC_MYBASE;
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
   	CWnd* pMainWnd = this;

    //return global app help mode state to FALSE (backward compatibility)
    pApp->m_bHelpMode = FALSE;
    pMainWnd->PostMessage(WM_KICKIDLE); //trigger idle update

    pMainWnd->WinHelp(lParam, HELP_CONTEXT);

    return TRUE;
}




