// encpage.cpp : implementation file
//	 cdialog

#include "stdafx.h"
#include "bwdialog.h"
#include "encpage.h"
#include "afxpriv.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

const static int MonoRates[]  ={32000,48000,56000,64000,80000,96000,112000,128000,160000,192000};
#define NumMonoRates (sizeof(MonoRates)/sizeof(int))

const static int StereoRates[]={64000,96000,112000,128000,160000,192000,224000,256000,320000,384000};
#define NumStereoRates (sizeof(StereoRates)/sizeof(int))

const static int AudioRates[] = {32000,48000,56000,64000,80000,96000,112000,128000,160000,192000,224000,256000,320000,384000};
#define NumAudioRates (sizeof(AudioRates)/sizeof(int))


IMPLEMENT_DYNCREATE(CEncodePage, CPropertyPage)

/////////////////////////////////////////////////////////////////////////////
// CEncodePage dialog
	  
void CEncodePage::SetModified( BOOL bModified )
{
	m_bChanged = bModified;
	CPropertyPage::SetModified( bModified );
}


CEncodePage::CEncodePage() 
	: CPropertyPage(CEncodePage::IDD)
{
	m_psp.dwFlags |= PSP_HASHELP;
	m_bChanged = FALSE;
	m_Mono = FALSE;

	GetSystemDirectory(m_iniFile.GetBufferSetLength(100),100);
	m_iniFile.ReleaseBuffer();
	m_iniFile+="\\bwtables\\mpegtype.ini";
}

void CEncodePage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEncodePage)
	DDX_Control(pDX, IDC_STA_IMAGESIZE, m_StaImageSize);
	DDX_Control(pDX, IDC_SIF, m_Sif);
	DDX_Control(pDX, IDC_SQUARE_STATIC, m_StaSquare);
	DDX_Control(pDX, IDC_SQUARE, m_Square);
	DDX_Control(pDX, IDC_STA_MBM2, m_StaMbm2);
	DDX_Control(pDX, IDC_STA_MBM, m_StaMbm);
	DDX_Control(pDX, IDC_STA_CHAN, m_StaChan);
	DDX_Control(pDX, IDC_STA_VIDEO, m_StaVideo);
	DDX_Control(pDX, IDC_VIDEOCHK, m_chkVideo);
	DDX_Control(pDX, IDC_PLAYBACK_TARGET, m_PlayBackTarget);
	DDX_Control(pDX, IDC_STA_RANGE_LOW2, m_StaRangeLow2);
	DDX_Control(pDX, IDC_STA_RANGE_LOW, m_StaRangeLow);
	DDX_Control(pDX, IDC_STA_RANGE_HIGH2, m_StaRangeHigh2);
	DDX_Control(pDX, IDC_STA_RANGE_HIGH, m_StaRangeHigh);
	DDX_Control(pDX, IDC_STA_MIDDLE2, m_StaMiddle2);
	DDX_Control(pDX, IDC_STA_MIDDLE, m_StaMiddle);
	DDX_Control(pDX, IDC_STA_LOW2, m_StaLow2);
	DDX_Control(pDX, IDC_STA_LOW, m_StaLow);
	DDX_Control(pDX, IDC_STA_HIGHER2, m_StaHigher2);
	DDX_Control(pDX, IDC_STA_HIGHER, m_StaHigher);
	DDX_Control(pDX, IDC_STA_DATARATE2, m_StaDataRate2);
	DDX_Control(pDX, IDC_STA_DATARATE, m_StaDataRate);
	DDX_Control(pDX, IDC_STA_AUDIO, m_StaAudio);
	DDX_Control(pDX, IDC_AUDIOCHK, m_chkAudio);
	DDX_Control(pDX, IDC_AUDIOQUALITY, m_AudioQualitySlider);
	DDX_Control(pDX, IDC_ENCODE_DEFAULTS, m_Defaults);
	DDX_Control(pDX, IDC_DISKSPACE, m_edDiskSpace);
	DDX_Control(pDX, IDC_VIDEOQUALITY, m_QualitySlider);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEncodePage, CPropertyPage)
	//{{AFX_MSG_MAP(CEncodePage)
	ON_BN_CLICKED(IDC_ENCODE_DEFAULTS, OnDefaults)
	ON_BN_CLICKED(IDC_AUDIOCHK, OnAudiochk)
	ON_BN_CLICKED(IDC_VIDEOCHK, OnVideochk)
	ON_BN_CLICKED(IDC_RBMONO, OnRbmono)
	ON_BN_CLICKED(IDC_RBJOINTSTEREO, OnRbjointstereo)
	ON_BN_CLICKED(IDC_RBDUALCHANNEL, OnRbdualchannel)
	ON_BN_CLICKED(IDC_RBSTEREO, OnRbstereo)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_CBN_SELCHANGE(IDC_PLAYBACK_TARGET, OnSelchangePlaybackTarget)
	ON_CBN_SELENDOK(IDC_PLAYBACK_TARGET, OnSelendokPlaybackTarget)
	ON_BN_CLICKED(IDC_SIF, OnSif)
	ON_BN_CLICKED(IDC_SQUARE, OnSquare)
	ON_EN_KILLFOCUS(IDC_VIDEO_EDIT, OnKillfocusVideoEdit)
	ON_EN_KILLFOCUS(IDC_AUDIO_EDIT, OnKillfocusAudioEdit)
	//}}AFX_MSG_MAP
    ON_MESSAGE( WM_COMMANDHELP, OnCommandHelp )
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CEncodePage message handlers

BOOL CEncodePage::OnInitDialog() 
{
	CRect dlgRect, buttonRect;
	
	CPropertyPage::OnInitDialog();

    LONG style = ::GetWindowLong(m_hWnd, GWL_EXSTYLE);
    style |= WS_EX_CONTEXTHELP;
    ::SetWindowLong(m_hWnd, GWL_EXSTYLE, style);

	// enable help button 
	CWnd* pHelpButton = GetDlgItem(ID_HELP);
	if (pHelpButton != NULL) {
		pHelpButton->ShowWindow(SW_SHOW);
	}
			 
	// get rid of some buttons we don't need 
	CWnd* pWnd = GetDlgItem (ID_HELP);
	if (pWnd) {
		pWnd->ShowWindow(FALSE);
	}

	pWnd = GetDlgItem (IDOK);
	if (pWnd) {
		pWnd->ShowWindow(FALSE);
	}

	pWnd = GetDlgItem (IDCANCEL);
	if (pWnd) {
		pWnd->ShowWindow(FALSE);
	}

	pWnd = GetDlgItem (IDC_ENCODE_DEFAULTS);
	WINDOWPLACEMENT wp1, wp2;

	wp1.length = wp2.length = sizeof(WINDOWPLACEMENT); 
	pWnd->GetWindowPlacement (&wp1);
	pWnd->CenterWindow();
	pWnd->GetWindowPlacement (&wp2);

	wp1.rcNormalPosition.left = wp2.rcNormalPosition.left;
	wp1.rcNormalPosition.right = wp2.rcNormalPosition.right;

	pWnd->SetWindowPlacement (&wp1);

	m_QualitySlider.SetRange(CalcQualityPos(83886), CalcQualityPos(3495253));  // in 400 bps intervals 
	int min,max;

	m_QualitySlider.GetRange(min,max);
	m_QualitySlider.SetTic((min+max)/2);
	
	m_AudioQualitySlider.SetRange(0, NumAudioRates-1);
	m_AudioQualitySlider.SetTic(NumAudioRates/2);
	
	//Set initial values
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	QualitySetPos( pApp->m_Settings.EncodeVideoBitRate());

	UINT nAudioMode = pApp->m_Settings.EncodeAudioMode();
	UINT bAudioEnable = pApp->m_Settings.EncodeAudioEnable();
	UINT bVideoEnable = pApp->m_Settings.EncodeVideoEnable();

	SetAudioMode( nAudioMode );

	m_chkAudio.SetCheck( bAudioEnable );
	m_chkVideo.SetCheck( bVideoEnable );

	UINT bSqarePixels = pApp->m_Settings.EncodeSquarePixels();
	SetSquarePixels( bSqarePixels );

	m_PlayBackTarget.ResetContent();
	char tStr[30];
	
	GetPrivateProfileString("RecodeTypes","Type1","Default",tStr,29,m_iniFile);
	int loop=2;
	while (tStr[0]!=0)
	{
		m_PlayBackTarget.AddString(tStr);
		char t1[10]="Type",t2[10];
		strcat(t1,itoa(loop++,t2,10));
		GetPrivateProfileString("RecodeTypes",t1,"",tStr,29,m_iniFile);
	}

	CEdit* edVideo = (CEdit*)GetDlgItem( IDC_VIDEO_EDIT );
	edVideo->SetLimitText(4);
	edit1.SubclassEdit(IDC_VIDEO_EDIT, this, PES_NUMBERS);

	CEdit* edAudio = (CEdit*)GetDlgItem( IDC_AUDIO_EDIT );
	edAudio->SetLimitText(4);
	edit2.SubclassEdit(IDC_AUDIO_EDIT, this, PES_NUMBERS);

	// if the EncodePlayBackTarget is bogus - this will give us a
    // valid default
	GetPrivateProfileString("RecodeTypes","Type1","Default",tStr,29,m_iniFile);
	m_PlayBackTarget.SelectString( 0,tStr ); 

	m_PlayBackTarget.SelectString( 0,pApp->m_Settings.EncodePlayBackTarget() ); 

	UpdateTargetSpecs();
	
	m_QualitySlider.SetSelection(CalcQualityPos(m_MinVideoRate), CalcQualityPos(m_MaxVideoRate));
    m_QualitySlider.Invalidate();

	UpdateAudioRates();
	SetAudioPos( pApp->m_Settings.EncodeAudioBitRate());

	UpdateSizeDisplay();

	RangeQualitySlider();
    RangeAudioSlider();

	EnableAudio( bAudioEnable );
	EnableVideo( bVideoEnable );

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEncodePage::OnDefaults() 
{
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	CString Target;
	m_PlayBackTarget.GetLBText(m_PlayBackTarget.GetCurSel(),Target);

	UINT nAudioType = GetPrivateProfileInt(Target,"AudioType",
		pApp->m_Settings.DefaultEncodeAudioMode(),m_iniFile);

	UINT nAudioEnable = GetPrivateProfileInt(Target,"AudioEnable",
		pApp->m_Settings.DefaultEncodeAudioEnable(),m_iniFile);

	UINT nEncodeVideoBitRate = GetPrivateProfileInt(Target,"DefaultVideoRate",
		pApp->m_Settings.DefaultEncodeVideoBitRate(),m_iniFile);

	UINT nEncodeAudioBitRate = GetPrivateProfileInt(Target,"DefaultAudioRate",
		pApp->m_Settings.DefaultEncodeAudioBitRate(),m_iniFile);

	UINT nEncodeSofteningLevel = GetPrivateProfileInt(Target,"VideoSoftness",pApp->m_Settings.DefaultEncodeSofteningLevel(),m_iniFile);

	m_QualitySlider.SetSelection(CalcQualityPos(m_MinVideoRate), CalcQualityPos(m_MaxVideoRate));
    m_QualitySlider.Invalidate();

	QualitySetPos( nEncodeVideoBitRate );

	SetAudioMode( nAudioType );
	m_chkAudio.SetCheck( nAudioEnable );
	EnableAudio( nAudioEnable );
	SetAudioPos( nEncodeAudioBitRate );
	
	m_chkVideo.SetCheck( pApp->m_Settings.DefaultEncodeVideoEnable() );
	EnableVideo( pApp->m_Settings.DefaultEncodeVideoEnable());

	m_AudioQualitySlider.SetSelection(CalcAudioPos(m_MinAudioRate), CalcAudioPos(m_MaxAudioRate));
	SetSquarePixels( pApp->m_Settings.DefaultEncodeSquarePixels() );

	m_Mono = nAudioType == AUDIO_MONO ?TRUE:FALSE;
   	UpdateAudioRates();
    m_AudioQualitySlider.SetSelection(CalcAudioPos(m_MinAudioRate), CalcAudioPos(m_MaxAudioRate));
    
	RangeAudioSlider();
    RangeQualitySlider();

	CWnd* pWnd = GetDlgItem (ID_HELP);
	if (pWnd) {
		pWnd->ShowWindow(FALSE);
	}

    pWnd = GetDlgItem (IDOK);
	if (pWnd) {
		pWnd->ShowWindow(FALSE);
	}

    pWnd = GetDlgItem (IDCANCEL);
	if (pWnd) {
		pWnd->ShowWindow(FALSE);
	}

	pWnd = GetDlgItem (IDC_ENCODE_DEFAULTS);
	WINDOWPLACEMENT wp1, wp2;

	wp1.length = wp2.length = sizeof(WINDOWPLACEMENT); 
	pWnd->GetWindowPlacement (&wp1);
	pWnd->CenterWindow();
	pWnd->GetWindowPlacement (&wp2);

	wp1.rcNormalPosition.left = wp2.rcNormalPosition.left;
	wp1.rcNormalPosition.right = wp2.rcNormalPosition.right;

	pWnd->SetWindowPlacement (&wp1);

	UpdateSizeDisplay();

	SetModified( TRUE );
}


void CEncodePage::SetSquarePixels( BOOL nSquarePixels )
{
	if ( nSquarePixels )
	{
		CheckRadioButton( IDC_SIF, IDC_SQUARE, IDC_SQUARE);
	} else {
		CheckRadioButton( IDC_SIF, IDC_SQUARE, IDC_SIF);
	}
}

BOOL CEncodePage::GetSquarePixels() 
{
	UINT nChecked = GetCheckedRadioButton( IDC_SIF, IDC_SQUARE);
	UINT nValue;

	switch (nChecked)
	{
		case IDC_SIF:
			nValue = FALSE;
			break;
		case IDC_SQUARE:
			nValue = TRUE;
			break;
		default:
			nValue = FALSE;
			break;
	}

	return( nValue );
}

UINT CEncodePage::SetAudioMode( UINT nAudioMode )
{
	BOOL bEnable = FALSE;

	switch( nAudioMode )
	{
		case AUDIO_MONO:
			CheckRadioButton( IDC_RBMONO, IDC_RBSTEREO, IDC_RBMONO);
			m_Mono=TRUE;
			break;
		case AUDIO_JOINTSTEREO:
			CheckRadioButton( IDC_RBMONO, IDC_RBSTEREO, IDC_RBJOINTSTEREO);
			break;
		case AUDIO_DUALCHANNEL:
			CheckRadioButton( IDC_RBMONO, IDC_RBSTEREO, IDC_RBDUALCHANNEL);
			break;
		case AUDIO_STEREO:
			CheckRadioButton( IDC_RBMONO, IDC_RBSTEREO, IDC_RBSTEREO);
			break;
		default:
			CheckRadioButton( IDC_RBMONO, IDC_RBSTEREO, IDC_RBJOINTSTEREO);
			break;
	}

	return( bEnable );
}


void CEncodePage::EnableAudio( BOOL bEnable ) 
{											   
	CWnd *pWnd = GetDlgItem( IDC_RBMONO );
	pWnd->EnableWindow( bEnable && m_MonoAudioEnabled && !m_AudioTypeFixed);
	pWnd = GetDlgItem( IDC_RBJOINTSTEREO );
	pWnd->EnableWindow( bEnable && m_StereoAudioEnabled && !m_AudioTypeFixed);
	pWnd = GetDlgItem( IDC_RBDUALCHANNEL );
	pWnd->EnableWindow( bEnable && m_StereoAudioEnabled && !m_AudioTypeFixed);
	pWnd = GetDlgItem( IDC_RBSTEREO );
	pWnd->EnableWindow( bEnable && m_StereoAudioEnabled && !m_AudioTypeFixed);

	m_StaChan.EnableWindow( bEnable );

	// video CD - no other choices
	if (m_MaxAudioRate == m_MinAudioRate) {
		bEnable = FALSE;
	}

	//Enable/disable the audio compression slider
	m_StaRangeLow2.EnableWindow( bEnable );
	m_StaRangeHigh2.EnableWindow( bEnable );
	m_StaMiddle2.EnableWindow( bEnable );
	m_StaLow2.EnableWindow( bEnable );
	m_StaHigher2.EnableWindow( bEnable );
	m_StaDataRate2.EnableWindow( bEnable );
	m_StaAudio.EnableWindow( bEnable );
	m_StaMbm2.EnableWindow( bEnable );
	m_AudioQualitySlider.EnableWindow( bEnable );

	CEdit* edAudio = (CEdit*)GetDlgItem( IDC_AUDIO_EDIT );
	edAudio->EnableWindow( bEnable );
}

void CEncodePage::EnableVideo( BOOL bEnable ) 
{
	// video CD - no other choices
	if (m_MaxVideoRate == m_MinVideoRate) {
		bEnable = FALSE;
	}

	//Enable/disable the video compression slider
	m_StaRangeLow.EnableWindow( bEnable );
	m_StaRangeHigh.EnableWindow( bEnable );
	m_StaMiddle.EnableWindow( bEnable );
	m_StaLow.EnableWindow( bEnable );
	m_StaHigher.EnableWindow( bEnable );
	m_StaVideo.EnableWindow( bEnable );
	m_StaMbm.EnableWindow( bEnable );
	m_StaDataRate.EnableWindow( bEnable );
	m_QualitySlider.EnableWindow( bEnable );
	
	m_Sif.EnableWindow( bEnable );

	CEdit* edVideo = (CEdit*)GetDlgItem( IDC_VIDEO_EDIT );
	edVideo->EnableWindow( bEnable );

	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
		
	int SquareEnable = !m_DisableSquarePixels && bEnable && pApp->m_Settings.IsEncode();
	m_StaImageSize.EnableWindow(SquareEnable);
	m_Sif.EnableWindow(SquareEnable);
	m_Square.EnableWindow(SquareEnable);
	m_StaSquare.EnableWindow(SquareEnable);
}

void CEncodePage::OnSif() 
{
   	SetModified( TRUE );
}

void CEncodePage::OnSquare() 
{
   	SetModified( TRUE );
}

void CEncodePage::OnAudiochk() 
{
	UINT nCheck = m_chkAudio.GetCheck( );

	EnableAudio( nCheck );
	if (nCheck == FALSE) {
		m_chkVideo.SetCheck( TRUE );
		EnableVideo( TRUE );
	}

	UpdateSizeDisplay();
   	SetModified( TRUE );
}

void CEncodePage::OnVideochk() 
{
	UINT nCheck = m_chkVideo.GetCheck( );

	EnableVideo( nCheck );
	if (nCheck == FALSE) {
		m_chkAudio.SetCheck( TRUE );
		EnableAudio( TRUE );
	}

	UpdateSizeDisplay();
   	SetModified( TRUE );
}

UINT CEncodePage::GetAudioMode() 
{
	UINT nValue = AUDIO_JOINTSTEREO;
	UINT nChecked = GetCheckedRadioButton( IDC_RBMONO, IDC_RBSTEREO);
	switch (nChecked)
	{
		case IDC_RBMONO:
			nValue = AUDIO_MONO;
			break;
		case IDC_RBJOINTSTEREO:
			nValue = AUDIO_JOINTSTEREO;
			break;
		case IDC_RBDUALCHANNEL:
			nValue = AUDIO_DUALCHANNEL;
			break;
		case IDC_RBSTEREO:
			nValue = AUDIO_STEREO;
			break;
		default:
			nValue = AUDIO_STEREO;
			break;
	}

	return( nValue );
}

UINT CEncodePage::GetAudioEnable()
{
	if (m_chkAudio.GetCheck( ) ) {
		return( 1 );
	}

	return( 0 );
}


UINT CEncodePage::GetVideoEnable()
{
	if (m_chkVideo.GetCheck( ) ) {
		return( 1 );
	}

	return( 0 );
}


BOOL CEncodePage::OnKillActive( )
{
	m_PlayBackTarget.GetLBText(m_PlayBackTarget.GetCurSel(),m_Target);
	m_VideoEnable = GetVideoEnable();
	m_SquarePixels = GetSquarePixels();

	if (m_MaxVideoRate == m_MinVideoRate) {
		m_VideoRate = m_MaxVideoRate;
	} else {
		m_VideoRate = QualityGetPos();
	}
		
	m_AudioEnable = GetAudioEnable();
	m_AudioMode = GetAudioMode();
		
	if (m_MaxAudioRate == m_MinAudioRate) {
		m_AudioRate = m_MaxAudioRate;
	} else {
		m_AudioRate = GetAudioPos();
	}
		
	long bitrate = 0L;

	if (GetVideoEnable()) {
		bitrate = QualityGetPos();
	}
	if (GetAudioEnable()) {
		bitrate += GetAudioPos();
	}

    m_CompressionEstimate = bitrate;

	m_OptimumRate = GetPrivateProfileInt(m_Target,"OptimumStreamRate",1,m_iniFile);
    m_StreamDataRate = GetPrivateProfileInt(m_Target,"StreamDataRate",1500000,m_iniFile);
    m_StreamPackSize = GetPrivateProfileInt(m_Target,"StreamPackSize",1024,m_iniFile);
    m_PacketsPerPack = GetPrivateProfileInt(m_Target,"PacketsPerPack",1,m_iniFile);
	
	return TRUE;
}

void CEncodePage::OnCancel() 
{
	CPropertyPage::OnCancel();
}

void CEncodePage::OnOK() 
{
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	if (m_bChanged)
	{
        pApp->m_Settings.SetEncodePlayBackTarget(m_Target);
		pApp->m_Settings.SetEncodeVideoEnable(m_VideoEnable);
		pApp->m_Settings.SetEncodeVideoBitRate(m_VideoRate);
		pApp->m_Settings.SetEncodeSquarePixels(m_SquarePixels);
		pApp->m_Settings.SetEncodeAudioEnable(m_AudioEnable);
		pApp->m_Settings.SetEncodeAudioBitRate(m_AudioRate);
		pApp->m_Settings.SetEncodeAudioMode(m_AudioMode);
        pApp->m_Settings.SetCompressionEstimate(m_CompressionEstimate);
	    pApp->m_Settings.SetEncodeUseOptimumRate(m_OptimumRate);
        pApp->m_Settings.SetEncodeStreamDataRate(m_StreamDataRate);
        pApp->m_Settings.SetEncodePackSize(m_StreamPackSize);
        pApp->m_Settings.SetEncodePacketsPerPack(m_PacketsPerPack);
	    pApp->m_Settings.SetStreamMixType(m_StreamMixType);
	    pApp->m_Settings.SetLargeImage(m_nLargeImage);

		SetModified( FALSE );
	}

	CPropertyPage::OnOK();
}

void CEncodePage::OnRbmono() 
{
	m_Mono=TRUE;
   	UpdateAudioRates();
    m_AudioQualitySlider.SetSelection(CalcAudioPos(m_MinAudioRate), CalcAudioPos(m_MaxAudioRate));
    RangeAudioSlider();
	UpdateSizeDisplay();
	SetModified( TRUE );
}

void CEncodePage::OnRbjointstereo() 
{
	m_Mono=FALSE;
   	UpdateAudioRates();
    m_AudioQualitySlider.SetSelection(CalcAudioPos(m_MinAudioRate), CalcAudioPos(m_MaxAudioRate));
    RangeAudioSlider();
	UpdateSizeDisplay();
	SetModified( TRUE );
}

void CEncodePage::OnRbdualchannel() 
{
	m_Mono=FALSE;
   	UpdateAudioRates();
    m_AudioQualitySlider.SetSelection(CalcAudioPos(m_MinAudioRate), CalcAudioPos(m_MaxAudioRate));
    RangeAudioSlider();
	UpdateSizeDisplay();
	SetModified( TRUE );
}

void CEncodePage::OnRbstereo() 
{
	m_Mono=FALSE;
   	UpdateAudioRates();
    m_AudioQualitySlider.SetSelection(CalcAudioPos(m_MinAudioRate), CalcAudioPos(m_MaxAudioRate));
    RangeAudioSlider();
	UpdateSizeDisplay();
	SetModified( TRUE );
}

void CEncodePage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    //handle scroll message based on source window
    HWND sourceWnd = pScrollBar->GetSafeHwnd();
    if (sourceWnd == NULL) {
        
		//default processing if no source
		CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
    }
	else if (sourceWnd == m_AudioQualitySlider.GetSafeHwnd()) {
		RangeAudioSlider();
		SetModified( TRUE );
	}
	else if (sourceWnd == m_QualitySlider.GetSafeHwnd()) {
		RangeQualitySlider();
		SetModified( TRUE );
	}
    else {

        //default processing if some other source
		CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
    }
}

void CEncodePage::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    //handle scroll message based on source window
    HWND sourceWnd = pScrollBar->GetSafeHwnd();
    if (sourceWnd == NULL) {

        //default processing if no source
		CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
    }
	else if (sourceWnd == m_AudioQualitySlider.GetSafeHwnd()) {
		RangeAudioSlider();
		SetModified( TRUE );
	}
	else if (sourceWnd == m_QualitySlider.GetSafeHwnd()) {
		RangeQualitySlider();
		SetModified( TRUE );
	}
    else {

        //default processing if some other source
		CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
    }
}

void CEncodePage::OnSelchangePlaybackTarget() 
{
	// TODO: Add your control notification handler code here
//	UpdateTargetSpecs();
	SetModified( TRUE );

}

void CEncodePage::UpdateAudioRates()
{
	int i;
	m_AudioQualitySlider.ClearTics();
	if (m_Mono) {
		for (i=0;i<NumMonoRates;i++) {
   		    m_AudioQualitySlider.SetTic(CalcAudioPos(MonoRates[i]));
         }
    } else {
		for (i=0;i<NumStereoRates;i++) {
   		    m_AudioQualitySlider.SetTic(CalcAudioPos(StereoRates[i]));
         }
    }
}

void CEncodePage::UpdateTargetSpecs()
{
	CString Target;
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	m_PlayBackTarget.GetLBText(m_PlayBackTarget.GetCurSel(),Target);

	m_MaxAudioRate=GetPrivateProfileInt(Target,"MaxAudioRate",384000,m_iniFile);
	m_MinAudioRate=GetPrivateProfileInt(Target,"MinAudioRate",32000,m_iniFile);

	UpdateAudioRates();
    RangeAudioSlider();

    m_AudioQualitySlider.SetSelection(CalcAudioPos(m_MinAudioRate), CalcAudioPos(m_MaxAudioRate));
    m_AudioQualitySlider.UpdateWindow();
	m_AudioQualitySlider.EnableWindow( m_MinAudioRate!=m_MaxAudioRate );

	m_AudioTypeFixed=GetPrivateProfileInt(Target,"AudioFixed",FALSE,m_iniFile);
	m_MonoAudioEnabled=GetPrivateProfileInt(Target,"MonoAudioEnable",TRUE,m_iniFile);
	m_StereoAudioEnabled=GetPrivateProfileInt(Target,"StereoAudioEnable",TRUE,m_iniFile);

	m_DisableAudioOnly = GetPrivateProfileInt(Target,"DisableAudioOnly",FALSE,m_iniFile); 
	m_DisableVideoOnly = GetPrivateProfileInt(Target,"DisableVideoOnly",FALSE,m_iniFile); 

	m_chkAudio.EnableWindow (!m_DisableAudioOnly && !m_AudioTypeFixed);

	m_chkVideo.EnableWindow (!m_DisableVideoOnly);

	m_DisableSquarePixels = GetPrivateProfileInt(Target,"DisableSquarePixels",FALSE,m_iniFile);

	m_MaxVideoRate=GetPrivateProfileInt(Target,"MaxVideoRate",5000000,m_iniFile);
	m_MinVideoRate=GetPrivateProfileInt(Target,"MinVideoRate",250000,m_iniFile);

	m_QualitySlider.SetSelection(CalcQualityPos(m_MinVideoRate), CalcQualityPos(m_MaxVideoRate));
    m_QualitySlider.Invalidate();

	m_MaxVideoRate=GetPrivateProfileInt(Target,"MaxVideoRate",5000000,m_iniFile);
	m_MinVideoRate=GetPrivateProfileInt(Target,"MinVideoRate",250000,m_iniFile);
	RangeQualitySlider();
    
    m_QualitySlider.SetSelection(CalcQualityPos(m_MinVideoRate), CalcQualityPos(m_MaxVideoRate));
	m_QualitySlider.EnableWindow( m_MinVideoRate!=m_MaxVideoRate );
    m_QualitySlider.Invalidate();	

	m_StreamMixType=GetPrivateProfileInt(Target,"StreamMixType",0,m_iniFile);

	int nVideoQsif = GetPrivateProfileInt(Target,"VideoQsif",FALSE,m_iniFile);

	CString sString;

	if (nVideoQsif) {
		m_nLargeImage = 0;
		sString.LoadString(IDS_QSIF);
		m_Sif.SetWindowText(sString);
		sString.LoadString(IDS_SQUARESMALL);
		m_StaSquare.SetWindowText(sString);
	} else {
		m_nLargeImage = 1;
		sString.LoadString(IDS_SIF);
		m_Sif.SetWindowText(sString);
		sString.LoadString(IDS_SQUARELARGE);
		m_StaSquare.SetWindowText(sString);
	}

	EnableAudio (TRUE);
	EnableVideo (TRUE);
}

void CEncodePage::RangeQualitySlider()
{
	int pos=QualityGetPos();
	if (pos>m_MaxVideoRate)
		QualitySetPos(m_MaxVideoRate);
	if (pos<m_MinVideoRate)
		QualitySetPos(m_MinVideoRate);

	char tmp[30];

	long bitrate=QualityGetPos();
	sprintf (tmp, "%.1f", BW_EncodeRateToMBm(bitrate));

	CEdit* edVideo = (CEdit*)GetDlgItem( IDC_VIDEO_EDIT );
	edVideo->SetWindowText(tmp);

	UpdateSizeDisplay();
}

void CEncodePage::RangeAudioSlider()
{
    int pos = GetAudioPos();
	SetAudioPos(pos);
	char tmp[30];
		
   	long bitrate=GetAudioPos();
	sprintf (tmp, "%.1f", BW_EncodeRateToMBm(bitrate));
	CEdit* edAudio = (CEdit*)GetDlgItem( IDC_AUDIO_EDIT );
	edAudio->SetWindowText(tmp);

	UpdateSizeDisplay();
}

void CEncodePage::UpdateSizeDisplay()
{
	char tmp[30];
	long bitrate = 0L;

	if (GetVideoEnable()) {
		bitrate = QualityGetPos();
	}
	if (GetAudioEnable()) {
		bitrate += GetAudioPos();
	}

	sprintf (tmp, "%.1f", BW_EncodeRateToMBm(bitrate));
	m_edDiskSpace.SetWindowText(tmp);

}

int CEncodePage::GetAudioPos()
{
	return AudioRates[m_AudioQualitySlider.GetPos()];
}

void CEncodePage::SetAudioPos(int pos)
{
    m_AudioQualitySlider.SetPos(CalcAudioPos(pos));
	return;
}

int CEncodePage::CalcAudioPos(int pos)
{
	int i;
    int *pRates;
    int nRates;

    if (pos > m_MaxAudioRate) {
        pos = m_MaxAudioRate;
    } else if (pos < m_MinAudioRate) {
        pos = m_MinAudioRate;
    }

	if (m_Mono) {
        pRates = (int *)MonoRates;
        nRates = NumMonoRates;
    } else {
        pRates = (int *)StereoRates;
        nRates = NumStereoRates;
    }

    if (pos > pRates[nRates-2]) {
        pos = pRates[nRates-1];
    } else if (pos < pRates[0]) {
        pos = pRates[0];
    } else for (i=0;i<nRates-1;i++) {
        if (pos == pRates[i]) {
            pos = pRates[i];
            break;
        } else if (pos > pRates[i] && pos < pRates[i+1]) {
            pos = pRates[i+1];
            break;
        }
    }

	for (i=0;i<NumAudioRates;i++)
	{
		if (AudioRates[i]==pos)
		{
			return (i);
		}
	}
	return 0;
}

int CEncodePage::QualityGetPos()
{
	return (int)exp(m_QualitySlider.GetPos()/1000.0)*400;
}

void CEncodePage::QualitySetPos(int pos)
{
	m_QualitySlider.SetPos(CalcQualityPos(pos));
}

int CEncodePage::CalcQualityPos(int pos)
{
// log function
	return (int)(1000*log((double)(pos/400)));
}

void CEncodePage::OnSelendokPlaybackTarget() 
{
	// TODO: Add your control notification handler code here
    UpdateTargetSpecs();
    OnDefaults();           
} 									

LRESULT CEncodePage::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	// TODO: Add your specialized code here and/or call the base class
	if (message == WM_HELP)	{
		HELPINFO* pHelpInfo = (HELPINFO*) lParam;
		int iCtrlId = pHelpInfo->iCtrlId;		

		if (iCtrlId == IDOK || iCtrlId == IDCANCEL || iCtrlId == ID_HELP) {
			pHelpInfo->iCtrlId = IDC_ENCODE_OPTIONS;
		}
		
		OnHelpInfo(pHelpInfo);
		return TRUE;
	} else if (message == WM_COMMAND)	{
		if (wParam == ID_HELP) {
			HELPINFO HelpInfo;

			HelpInfo.iContextType = HELPINFO_WINDOW;
			HelpInfo.iCtrlId = IDC_ENCODE_OPTIONS;
			OnHelpInfo(&HelpInfo);
			return TRUE;
		}
	}

	return CPropertyPage::WindowProc(message, wParam, lParam);
}


BOOL CEncodePage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if ( pHelpInfo->iContextType==HELPINFO_WINDOW )
	{
		long lParam = pHelpInfo->iCtrlId + HIDC_MYBASE;
    	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
    	CWnd* pMainWnd = this;

	    // return global app help mode state to FALSE (backward compatibility)
	    pApp->m_bHelpMode = FALSE;
	    pMainWnd->PostMessage(WM_KICKIDLE); // trigger idle update

        pMainWnd->WinHelp(lParam, HELP_CONTEXT);
	}
	return TRUE;
}

LRESULT CEncodePage::OnCommandHelp( WPARAM, LPARAM lParam )
{
    int nCtrlID = GetFocus()->GetDlgCtrlID(); // Get the ID of the control with the current focus

	lParam = nCtrlID + HIDC_MYBASE;
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
   	CWnd* pMainWnd = this;

    // return global app help mode state to FALSE (backward compatibility)
    pApp->m_bHelpMode = FALSE;
    pMainWnd->PostMessage(WM_KICKIDLE); // trigger idle update

    pMainWnd->WinHelp(lParam, HELP_CONTEXT);

    return TRUE;
}



					
void CEncodePage::OnKillfocusVideoEdit() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	CString sValue;
	double Value;

	CEdit* edVideo = (CEdit*)GetDlgItem( IDC_VIDEO_EDIT );

	edVideo->GetWindowText(sValue);
	int nLength = sValue.GetLength();

	if (nLength == 0) {
		RangeQualitySlider();
		return;
	}				
	
	char tmp[30];

	Value = atof (sValue);
	long bitrate=QualityGetPos();

	sprintf (tmp, "%.1f", BW_EncodeRateToMBm(bitrate));
	if (sValue == tmp) {
		return;	
	}

	Value = min (Value, 25.0);
	int nPos = (int) ((Value * (1024*1024) * 8) / 60);

	nPos = min (m_MaxVideoRate, nPos);
	nPos = max (m_MinVideoRate, nPos);
	QualitySetPos(nPos);
	RangeQualitySlider();

	SetModified( TRUE );
}

void CEncodePage::OnKillfocusAudioEdit() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	CString sValue;
	double Value;

	CEdit* edAudio = (CEdit*)GetDlgItem( IDC_AUDIO_EDIT );

	edAudio->GetWindowText(sValue);
	int nLength = sValue.GetLength();

	if (nLength == 0) {
		RangeAudioSlider();
		return;
	}				
	
	char tmp[30];

	Value = atof (sValue);
	long bitrate=GetAudioPos();

	sprintf (tmp, "%.1f", BW_EncodeRateToMBm(bitrate));
	if (sValue == tmp) {
		return;	
	}

	Value = min (Value, 3.0);
	int nPos = (int) ((Value * (1024*1024) * 8) / 60);

	nPos = min (m_MaxAudioRate, nPos);
	nPos = max (m_MinAudioRate, nPos);
	SetAudioPos(nPos);
	RangeAudioSlider();

	SetModified( TRUE );
}