// mark.cpp : implementation file
//

#include "stdafx.h"
#include "mark.h"

/////////////////////////////////////////////////////////////////////////////
// CMark

CMark::CMark()
{
}

CMark::~CMark()
{
}

void CMark::SetBitmap(int nID)
{
	m_nBitmap = nID;
}

BEGIN_MESSAGE_MAP(CMark, CButton)
	//{{AFX_MSG_MAP(CMark)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



void CMark::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	CDC *pDC;
	pDC = CDC::FromHandle(lpDrawItemStruct->hDC);

	CBitmap OutBitmap;

	OutBitmap.LoadBitmap(m_nBitmap);

	TransBitBlt( pDC, lpDrawItemStruct->rcItem.left, lpDrawItemStruct->rcItem.top,
		lpDrawItemStruct->rcItem.right-lpDrawItemStruct->rcItem.left,		
		lpDrawItemStruct->rcItem.bottom-lpDrawItemStruct->rcItem.top,
		OutBitmap, RGB(255, 255, 255) );
}

BOOL CMark::TransBitBlt( CDC* pdcScreen, UINT x, UINT y, UINT dx, UINT dy,
			CBitmap& cImageBitmap, COLORREF crTransparent )
{
	ASSERT( pdcScreen );

	// Get the dimensions of the bitmap image.
	BITMAP bm;
	VERIFY( cImageBitmap.GetObject( sizeof(BITMAP), &bm ) );

	// Create a DC for the image bitmap.
	CDC dcImage;
	VERIFY( dcImage.CreateCompatibleDC( pdcScreen ) );
	CBitmap* pOldImageBitmap = dcImage.SelectObject( &cImageBitmap );

	// Create a DC and monochrome bitmap for the mask.
	CDC dcMask;
	CBitmap cMaskBitmap;
	VERIFY( dcMask.CreateCompatibleDC( pdcScreen ) );
	VERIFY( cMaskBitmap.CreateBitmap( bm.bmWidth, bm.bmHeight, 1, 1, NULL ) );
	CBitmap* pOldMaskBitmap = dcMask.SelectObject( &cMaskBitmap );

	// Create a memory DC and bitmap to work on.
	CDC dcMem;
	CBitmap cMemBitmap;
	VERIFY( dcMem.CreateCompatibleDC( pdcScreen ) );
	VERIFY( cMemBitmap.CreateCompatibleBitmap( pdcScreen,
					bm.bmWidth, bm.bmHeight ) );
	CBitmap* pOldMemBitmap = dcMem.SelectObject( &cMemBitmap );

	// Create a monochrome mask of the image.
	COLORREF crBack = dcImage.SetBkColor( crTransparent );
	dcMask.BitBlt( 0, 0, bm.bmWidth, bm.bmHeight,
						&dcImage, 0, 0, SRCCOPY );
	dcImage.SetBkColor( crBack );

	// Create and select a brush of the background color.
	CBrush cBrush;
	cBrush.CreateSolidBrush( pdcScreen->GetBkColor() );
	CBrush *cOldBrush = dcMem.SelectObject( &cBrush );

	// Copy the unmodified image in the temporary bitmap.
	dcMem.BitBlt( 0, 0, bm.bmWidth, bm.bmHeight,
						&dcImage, 0, 0, SRCCOPY );

	// Force conversion of the monochrome to stay B&W.
	COLORREF crText = dcMem.SetTextColor( 0L );
	crBack = dcMem.SetBkColor( RGB(255,255,255) );
								   
   	// Perform the masking copy.
	dcMem.BitBlt( 0, 0, bm.bmWidth, bm.bmHeight, &dcMask, 0, 0,
						0x00E20746 /* ROP_DSPDxax */ );
	
	// Copy the final image to the screen.	
	//pdcScreen->BitBlt( x, y, bm.bmWidth, bm.bmHeight,
	//							&dcMem, 0, 0, SRCCOPY );
					
	pdcScreen->StretchBlt( x, 
						   y,
						   dx,
						   dy,
						   &dcMem, 
						   0, 
						   0, 
						   bm.bmWidth, 
						   bm.bmHeight, 
						   SRCCOPY );


	// Restore the original device context.
	dcMem.SetTextColor( crText );
	dcMem.SetBkColor( crBack );
	dcMem.SelectObject( cOldBrush );
	
	// Select the bitmaps out of the DCs.	
	dcImage.SelectObject( pOldImageBitmap );
	dcMask.SelectObject( pOldMaskBitmap );
	dcMem.SelectObject( pOldMemBitmap );
			 			
	// Delete all the objects we CREATEd.
	VERIFY( dcImage.DeleteDC() );
	VERIFY( dcMask.DeleteDC() );
	VERIFY( dcMem.DeleteDC() );
	
	VERIFY( cBrush.DeleteObject() );
	VERIFY( cMemBitmap.DeleteObject() );
	VERIFY( cMaskBitmap.DeleteObject() );

	return( TRUE );
}

