// VT_Access.h
#ifndef __VT_Access
#define __VT_Access



//#include "vt_regs.h"

typedef DWORD ECODE;
#define VT_NO_ERROR				0
#define VT_ERR_IREG_TIMEOUT		(1)
#define VT_ERR_UNSUPPORTED      2  // Software function is unsupported
#define VT_ERR_SIMB_FULL		3  //Schedualed Input message buffer
#define VT_ERR_PIMB_FULL		4  //Priority Input Message Buffer
#define VT_ERR_OMB_EMPTY		5	// Output Message Buffer
#define VT_ERR_INVALID_COMMAND	6
#define VT_ERR_PROGRAMED_RANGE	7  // a fatal range of legal values has been exceeded 
#define VT_ERR_BAD_STRUCT_SIZE	8
#define VT_ERR_HW_BUSY			9
#define VT_ERR_SR_WRITE			10  // Serial write to VIP failed
#define VT_VIP_UNDEFINED		11  // VIP is in an udefined state
#define VT_NOT_HSUNK			12  // The VIP is not sunk to an input source
#define VT_NOT_MATCHED			13	// The input signal does not match the configured color mode
#define VT_ERR_VRP_SEL			14	// The vrp select bit is in the incorect state
#define VT_ERR_FIFO_EMPTY		15  // The Fifo is empty
#define VT_ERR_FILE_NOT_FOUND	16
#define VT_ERR_FIFOOVERFLOW		17
#define VT_ERR_BOARD_NOT_FOUND  18
#define VT_ERR_NO_MODE			19   // Must call vt set mode first
#define VT_ERR_LOCAL_TIMEOUT	20	// VRP is not taking data over Local port
#define VT_ERR_NO_FREE_BUFFERS	21
#define VT_ERR_INCOMPATIBLE_HARDWARE 22 // This driver version is not compatible with hardware version
#define VT_ERR_HARDWARE_FAILURE 23
#define VT_ERR_NULL_DEVID		24
#define VT_ERR_HARDWARE_NOT_CAPABLE 25
#define VT_ERR_OTHER			100  // Some other error occured check the error string

#define MAX_COMMAND_PARAMS 15

#pragma pack(1)
#pragma warning (disable:4200)
typedef struct _VRP_COMMAND{
	unsigned short command;
	unsigned short size;
	DWORD params[];
} VRP_COMMAND;
#pragma warning (default:4200)
typedef struct TIMECODE{
	unsigned pictures:8;
	unsigned seconds:8;
	unsigned minutes:8;
	unsigned hours:8;
} TC;


#pragma pack()

struct _CAPTUREINFO{
	DWORD StructSize;
	DWORD FrameRate;  // framerate in microseconds per frame
	DWORD DataRate;
	DWORD Quality;
	DWORD Padding;
	short FrameWidth;
	short FrameHeight;
	short PassMode;   /*  1:full frame, 2: subsampled*/ 
	short SourceIsVcr; /* 0=false 1=true */
	short Aspect;
	short Hue;
	short Saturation;
	short Intensity;
	short Contrast;
	short ShiftLeft;
	short ShiftUp;
	short Blanklines;
	short FilterValue;
	short FixedQuant; // 0=false 1=true
	short FrameType;
	short IBP;	// (FALSE,TRUE)
};
typedef struct _CAPTUREINFO CAPTUREINFO;

struct _COMPRESSINFO{
	DWORD StructSize;
	DWORD FrameType;
	DWORD FrameRate;
	DWORD DataRate;
	DWORD Quality;
	DWORD Padding;
	short FrameWidth;
	short FrameHeight;
	DWORD Aspect;
};
typedef struct _COMPRESSINFO COMPRESSINFO;

struct _RECODEINFO{
	DWORD StructSize;
	DWORD FrameRate;
	DWORD DataRate;
	DWORD FrameType;
	short FrameWidth;
	short FrameHeight;
	short NominalGopSize;
	short IntrapictureDistance;
	short ReferenceDistance;
	short SequenceHeaderRepeatInterval;
	short Padding;
	short DynamicIntrapictureInsertion;
	DWORD Aspect;
	DWORD Quality;
	DWORD FilterValue;
	long ShiftUp;
	long ShiftLeft;
	long BlankLines;
};
typedef struct _RECODEINFO RECODEINFO;

typedef enum {MASTER1=1,MASTER2} DMA_MODES;
typedef enum {FRAMERATE, DATARATE, FRAMEWIDTH, FRAMEHEIGHT, ASPECT,
 HUE, SATURATION, INTENSITY, CONTRAST, FRAMETYPE, QUALITY, PADDING, 
 FILTERVALUE, SHIFTUP, SHIFTLEFT, BLANKLINES, PASSMODE, SOURCEISVCR,
 CODECMODE, RECODEBYPASS, RECODEBLOCKSIZE,PLAYBACKDEST} VTPARAM;

typedef enum {BUFFERS_PENDING=0X100} STATUS_TYPES;

// Frame types for us in with FRAMETYPE param
typedef enum {FT_NTSC,FT_NTSC_FILM,FT_PAL,FT_SQPIXEL,
			 FT_NTSC_QSIF,FT_NTSC_FILM_QSIF,FT_PAL_QSIF,FT_SQPIXEL_QSIF} FRAME_TYPE;

typedef enum VTMODES{VT_IDLE,VT_IENCODE,VT_ICOMPRESS,VT_IDECOMPRESS,
					VT_IDECODE, VT_RECODE,VT_IBPENCODE,VT_LBRENCODE, VT_DIAG1=10,VT_DIAG2} VTMODE;
#define VT_CODEC VT_ICOMPRESS

typedef enum VTSTATES{VTS_CONFIGNEEDED,VTS_READY,VTS_RUNNING,VTS_PAUSED,VTS_ERROR} VTSTATE;

#ifdef USE_LIB
#define VT_INTERFACE __stdcall
#else
#ifdef BUILD_DLL
#define  VT_INTERFACE  __declspec(dllexport) __stdcall
#else
#define VT_INTERFACE __declspec(dllimport) __stdcall
//VT_INTERFACE char *VT_ErrorMessage;
#endif
#endif //USE_LIB
// if vt_regs has not been included then define devid as a dword

#if defined(__cplusplus) && !defined(NO_CDEVICE)  
class CDevice;
typedef CDevice *DEVID;
#else
typedef struct _DEVSTRUCT *DEVID ;
#endif


// Define Memory types
typedef enum {VR_DRAM, VR_GBUS, VR_WBUS,
			 VR_IMEM, VR_SMEM, VR_RMEM, CR_REGS,SR_REGS, VR_AFIFO, VR_BFIFO, SR_FLASH}  VT_MEMTYPE ;

// RGB NOT SUPPORTED YET
typedef enum {YUV_ENCODE,YUV_DECODE,RGB_ENCODE,RGB_DECODE} CODEC_MODE;

// Define Video modes
#define NTSC 1
#define PAL 2
#define AUTO_DETECT 3

#define COMPOSITE 1
#define SVIDEO 2



#ifdef __cplusplus
extern "C" {
#endif

// Opening and accessing a device
ECODE VT_INTERFACE VT_OpenDevice(LPTSTR pDriverName, DWORD DeviceIndex, DEVID *dwDevice);
ECODE VT_INTERFACE VT_DeleteDevice(DEVID dwDevice);
ECODE VT_INTERFACE VT_Reset(DEVID dwDevice);
ECODE VT_INTERFACE VT_GetHW(DEVID dwDevice,DWORD TimeOutms);    // sieze control of HW
ECODE VT_INTERFACE VT_ReleaseHW(DEVID dwDevice);  // release the HW
ECODE VT_INTERFACE VT_GetRevisionID(DEVID dwDevice, UCHAR *pRevisionID); 
ECODE VT_INTERFACE VT_GetHardwareState(DEVID dwDevice, DWORD *pState); 

ECODE VT_INTERFACE VT_AquireMutex();
ECODE VT_INTERFACE VT_ReleaseMutex();


// High level access
ECODE VT_INTERFACE VT_SendCommand(DEVID dwDevice, const VRP_COMMAND *command);
ECODE VT_INTERFACE VT_SendPriorityCommand(DEVID dwDevice, const VRP_COMMAND *command);
ECODE VT_INTERFACE VT_SetupVideoMode(DEVID dwDevice,DWORD VidMode,DWORD VidSource);
ECODE VT_INTERFACE VT_GetVideoMode(DEVID dwDevice,DWORD *VidMode,DWORD *VidSource);
ECODE VT_INTERFACE VT_SetParam(DEVID dwDevice,DWORD param,long value);
ECODE VT_INTERFACE VT_GetParam(DEVID dwDevice,DWORD param,long *value);
ECODE VT_INTERFACE VT_GetStatus(DEVID dwDevice,DWORD param,long *value);

ECODE VT_INTERFACE VT_GetCaptureInfo(DEVID dwDevice,CAPTUREINFO *ConfigInfo);
ECODE VT_INTERFACE VT_SetCaptureInfo(DEVID dwDevice,CAPTUREINFO *ConfigInfo);
ECODE VT_INTERFACE VT_GetCodecInfo(DEVID dwDevice,COMPRESSINFO *CompressInfo);
ECODE VT_INTERFACE VT_SetCodecInfo(DEVID dwDevice,COMPRESSINFO *CompressInfo);
ECODE VT_INTERFACE VT_GetRecodeInfo(DEVID dwDevice,RECODEINFO *RecodeInfo);
ECODE VT_INTERFACE VT_SetRecodeInfo(DEVID dwDevice,RECODEINFO *RecodeInfo);
ECODE VT_INTERFACE VT_GetMode(DEVID dwDevice,DWORD *Mode);
ECODE VT_INTERFACE VT_SetMode(DEVID dwDevice,DWORD Mode);
ECODE VT_INTERFACE VT_Start(DEVID dwDevice);
ECODE VT_INTERFACE VT_Stop(DEVID dwDevice);
ECODE VT_INTERFACE VT_Pause(DEVID dwDevice);
ECODE VT_INTERFACE VT_Continue(DEVID dwDevice);
ECODE VT_INTERFACE VT_EnablePassthrough(DEVID dwDevice,int Enable);


ECODE VT_INTERFACE VT_WriteData(DEVID dwDevice, const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten);
ECODE VT_INTERFACE VT_ReadData(DEVID dwDevice,void **OutputPtr,DWORD *OutputWords);
typedef enum _VTBUFFERTYPE {VT_READBUFFER,VT_WRITEBUFFER} VTBUFFERTYPE; 
ECODE VT_INTERFACE VT_GetNextBuffer( DEVID dwDevice,VTBUFFERTYPE Type, void **BuffPtr, DWORD *SizeWords);



// Debug and diagnostic access
ECODE VT_INTERFACE VT_InitDevice(DWORD BoardPointer,DEVID *dwDevice);
ECODE VT_INTERFACE VT_InitDeviceEx(DWORD BoardPointer, LPCSTR TablePath, BOOL ShortBurst, DEVID *pdwDevice);
ECODE VT_INTERFACE VT_Read(DEVID dwDevice, VT_MEMTYPE Type, DWORD *DestPtr, DWORD Source, DWORD Words);
ECODE VT_INTERFACE VT_Write(DEVID dwDevice, VT_MEMTYPE Type, DWORD Dest, const DWORD *SrcPtr, DWORD Words);
ECODE VT_INTERFACE VT_ReadModifyWrite(DEVID dwDevice, VT_MEMTYPE Type, DWORD Dest, DWORD Mask, DWORD Data);



ECODE VT_INTERFACE VT_ResetVRP(DEVID dwDevice);

ECODE VT_INTERFACE VT_WritePortA(DEVID dwDevice, const DWORD *SrcPtr, DWORD Words);
ECODE VT_INTERFACE VT_ReadPortB(DEVID dwDevice, DWORD *DestPtr, DWORD Words);
ECODE VT_INTERFACE VT_SetupFifo(DEVID dwDevice,DWORD aEmpty,DWORD aFull);


ECODE VT_INTERFACE VT_GetCurrentTransferAddress(DEVID dwDevice,DWORD Master,DWORD *PhysicalAddress);
ECODE VT_INTERFACE VT_GetMaster2PreviousTransferedSize(DEVID dwDevice,DWORD *TransferSizeDwords);
ECODE VT_INTERFACE VT_LoadDma(DEVID dwDevice,DWORD Master,DWORD dwords,DWORD PhysicalAddress);
ECODE VT_INTERFACE VT_LoadFile(DEVID dwDevice,VT_MEMTYPE Type,char *filename);
ECODE VT_INTERFACE VT_LoadFileBin(DEVID dwDevice,VT_MEMTYPE Type,char *filename,DWORD Addr,DWORD LastAddr,DWORD FileOffset);

//ECODE VT_INTERFACE VT_WriteRecodeData(DEVID dwDevice, const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten);
//ECODE VT_INTERFACE VT_InitCircBuffer(DEVID dwDevice,DWORD PhysAddr,void *LinAddr,DWORD Size);
//DWORD VT_INTERFACE VT_ExtractNextFrame(DEVID dwDevice,void* *pStart);


// both sizes are in DWORDS Output buffer and size are returned by this routine and are in the Hardware
// buffer data must be removed from this buffer before the next Run
// The input data need not be in the Hardware Buffer

ECODE VT_INTERFACE VT_SetupHardwareBuffer(DEVID dwDevice,DWORD PhysAddr,void *LinAddr,DWORD Size); // set hardware buffer (size in bytes)

ECODE VT_INTERFACE VT_GetHardwareBuffer(DEVID dwDevice,DWORD *PhysAddr,
    void **LinAddr,DWORD *LinAddr16,DWORD *Size);

ECODE VT_INTERFACE VT_GetDeviceMemory(DEVID dwDevice, void **Regs,DWORD *Regs16);

ECODE VT_INTERFACE VT_FlushCache(DEVID dwDevice);


// Not yet Implemented
ECODE VT_INTERFACE VT_ModifyRecodeParam(DEVID dwDevice,TC tc,DWORD param,DWORD value);
ECODE VT_INTERFACE VT_SetIntCallback(DEVID dwDevice,void *(*func)(void),DWORD Imask);
ECODE VT_INTERFACE VT_ModifyInts(DEVID dwDevice,DWORD Imask,DWORD values);


// CODEC MUST BE LOADED FIRST
//ECODE VT_INTERFACE VT_SetCodecMode(DEVID dwDevice,CODEC_MODE Mode);

#ifdef __cplusplus
}
#endif

#endif
